<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use App\Models\ApiModels\StudentRegister;
use Exception;
use Illuminate\Validation\ValidationException;
use App\Models\Businessregister;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\File;
use App\Models\Salesubscription;
use App\Models\Subscription;
use Illuminate\Support\Carbon;
use App\Models\ApiModels\SelfStudentRegister;
use App\Models\ApiModels\OldStudentsRegister;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use App\Models\Reviews;
use App\Models\ApiModels\BussinessModel;
use Log;
use App\Models\ApiModels\StudentBooking;
use UnexpectedValueException;
use App\Models\ReferHostel;


class StudentRegistratonOptController extends controller
{
    // self Student Register oprations
    public function AddSelfToActiveRegister(Request $request)
    {
        try {
            $validator = Validator::make($request->all(), [
                'formNumber' => 'required',
                'roomNumber' => 'required',
                'seatNumber' => 'required',
                'registrationDate' => 'required|date',
                'selfStudentId' => 'required',
            ]);

            if ($validator->fails()) {
                throw new ValidationException($validator);
            }

            $checkFormNo = StudentRegister::where("formno", $request->formNumber)->first();
            if (!empty($checkFormNo)) {
                return response()->json([
                    'status' => false,
                    'message' => 'This Form Number is already registered'
                ], 422);
            }
            // check seat availability
            $checkSeatNo = StudentRegister::where("roomno", $request->roomNumber)
                ->where("seetno", $request->seatNumber)
                ->where("status", 1)
                ->first();

            if (!empty($checkSeatNo)) {
                return response()->json([
                    "status" => false,
                    'message' => "This seat is not available",
                    'data' => $checkSeatNo,
                ], 422);
            }
            $selfStudentDate = SelfStudentRegister::where("id", $request->selfStudentId)->first();

            if (empty($selfStudentDate)) {
                throw new Exception('Invalid self Student Id');
            }

            //    transefer self student data to registers studetn
            DB::beginTransaction();
            try {
                $newStudent = new Studentregister();
                $newStudent->formno = $request->formNumber;
                $newStudent->roomno = $request->roomNumber;
                $newStudent->seetno = $request->seatNumber;
                $newStudent->date = $request->registrationDate;
                $newStudent->candidatename = $selfStudentDate->candidatename;
                $newStudent->dob = $selfStudentDate->dob;
                $newStudent->valid = $selfStudentDate->aadhar;
                $newStudent->phone = $selfStudentDate->phone;
                $newStudent->email = $selfStudentDate->email;
                $newStudent->blood = $selfStudentDate->blood;
                $newStudent->healthissue = $selfStudentDate->healthissue;
                $newStudent->health_description = $selfStudentDate->health_description;
                $newStudent->stydrt = $selfStudentDate->stydrt;
                $newStudent->vehicalno = $selfStudentDate->vehicalno;
                $newStudent->vehicledescription = $selfStudentDate->vehicledescription;
                $newStudent->coursename = $selfStudentDate->course_job;
                $newStudent->coursedetails = $selfStudentDate->coursedetails;
                $newStudent->jobdetails = $selfStudentDate->jobdetails;
                $newStudent->companyname = $selfStudentDate->companyname;
                $newStudent->institute = $selfStudentDate->institute_company;
                $newStudent->institutename = $selfStudentDate->institutename;
                $newStudent->fathername = $selfStudentDate->fathername;
                $newStudent->fatheroocc = $selfStudentDate->fatheroocc;
                $newStudent->mothername = $selfStudentDate->mothername;
                $newStudent->motheroocc = $selfStudentDate->motheroocc;
                $newStudent->tel = $selfStudentDate->parentmobile1;
                $newStudent->mobilenumber = $selfStudentDate->parentmobile2;
                $newStudent->pemail = $selfStudentDate->pemail;
                $newStudent->fullAddress = $selfStudentDate->fullAddress;
                $newStudent->state = $selfStudentDate->state;
                $newStudent->pinno = $selfStudentDate->pinno;
                $newStudent->guardianname = $selfStudentDate->guardianname;
                $newStudent->guardiannumber = $selfStudentDate->guardiannumber;
                $newStudent->guardianaddress = $selfStudentDate->guardianaddress;
                $newStudent->uploadimage = $selfStudentDate->studentImg;
                $newStudent->uploadaadharfront = $selfStudentDate->uploadaadharfront;
                $newStudent->uploadaadharback = $selfStudentDate->uploadaadharback;
                $newStudent->candidatesign = $selfStudentDate->candidatesign;
                $newStudent->Parentsign = $selfStudentDate->Parentsign;
                $newStudent->referCode = strtoupper($selfStudentDate->referCode);

                $newStudent->save();
                if ($selfStudentDate->referCode != "") {
                    $refer = ReferHostel::where('referal_code', strtoupper($selfStudentDate->referCode))->first();
                    if (!empty($refer)) {
                        $refer->update([
                            'status' => 2,
                            'refered_student_id' => $newStudent->id,
                        ]);
                    }
                }
                // Delete the self student record
                $selfStudentDate->delete();
                // Commit the transaction
                DB::commit();
            } catch (Exception $e) {
                // Rollback the transaction in case of an error
                DB::rollBack();

                // Rethrow the exception
                throw $e;
            }

            return response()->json([
                'status' => true,
                'message' => 'Self Student added to Active Register successfully',
            ], 200);
        } catch (ValidationException $e) {
            return response()->json([
                'status' => false,
                'errors' => $e->errors(),
            ], 422);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage()
            ], 500);
        }
    }

    public function deleteSelfStudetsRecords($selfStudentId)
    {
        try {
            $selfStudent = SelfStudentRegister::find($selfStudentId);

            if (!$selfStudent) {
                return response()->json([
                    'status' => false,
                    'message' => 'Record not found.'
                ], 404);
            }

            $selfStudent->delete();

            return response()->json([
                'status' => true,
                'message' => 'Record deleted successfully.'
            ], 200);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage()
            ], 500);
        }
    }
    // old student table opt
    public function oldToMainRegister(Request $request)
    {
        try {
            // Validation
            $validator = Validator::make($request->all(), [
                'roomNumber' => 'required',
                'seatNumber' => 'required',
                'date' => 'required|date',
                'oldStudentId' => 'required'
            ]);

            if ($validator->fails()) {
                throw new ValidationException($validator);
            }

            // Check if the student exists in the old student list
            $studentExistCheck = OldStudentsRegister::find($request->oldStudentId);

            if (!$studentExistCheck) {
                return response()->json([
                    'status' => false,
                    'error' => 'No records in the old list'
                ], 404);
            }
            // Check room number and seat number availability
            $checkAvailableSeat = StudentRegister::where('roomno', $request->roomNumber)
                ->where('seetno', $request->seatNumber)
                ->where('status', 1)
                ->exists();

            if ($checkAvailableSeat) {
                return response()->json([
                    'status' => false,
                    'message' => "This room or seat is already occupied."
                ], 422);
            }

            // Update StudentRegister: join date, leave date to null, and status to 1
            $updateStudent = StudentRegister::where('formno', $studentExistCheck->formno)->first();

            if (!$updateStudent) {
                throw new Exception('Student not found in the main register');
            }

            $updateStudent->update([
                'roomno' => $request->roomNumber,
                'join_date' => $request->date,
                'leavedate' => null,
                'status' => 1,
            ]);

            return response()->json([
                'status' => true,
                'message' => 'Student transferred from old to main register successfully'
            ], 200);
        } catch (ValidationException $e) {
            return response()->json([
                'status' => false,
                'errors' => $e->errors(),
            ], 422);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage()
            ], 500);
        }
    }

    public function deleteOldStudentRecords($oldStudentId)
    {
        try {
            $oldStudent = OldStudentsRegister::findOrFail($oldStudentId);
            $oldStudent->delete();

            return response()->json([
                'status' => true,
                'message' => 'Record deleted successfully',
            ], 200);
        } catch (ModelNotFoundException $e) {
            return response()->json([
                'status' => false,
                'error' => 'Record not found for this old Student Id: ' . $oldStudentId,
            ], 404);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage(),
            ], 500);
        }
    }
    // main registration oprations 
    // 1.delete(main to old register)
    public function deleteMainRegister(Request $request, $studentId)
    {
        try {
            $validator = Validator::make($request->all(), [
                'leavingDate' => 'required|date',
                'paymentRating' => 'required|numeric',
                'behaviourRating' => 'required|numeric',
                'responsibleRating' => 'required|numeric',
                'AdditionCommant' => 'nullable|string',
            ]);

            if ($validator->fails()) {
                throw new ValidationException($validator);
            }

            DB::beginTransaction();

            $student = StudentRegister::where('id', $studentId)->where('status', 1)->first();
            if (empty($student)) {
                Log::error('student not Found: ', $studentId);
                return response()->json([
                    'status' => false,
                    'error' => "Student not found."
                ], 404);
            }

            $oldLeavingDate = $student->leave_date;
            $student->leave_date = $request->leavingDate;
            $student->status = 0;
            $student->save();

            $hostelName = $this->getHostelName();

            if (!$hostelName) {
                throw new Exception('Unable to retrieve hostel name');
            }

            $this->insertOrUpdateReviews($student, $hostelName, $request);

            $oldStudentRegister = $this->transferToOldRegister($student);

            if (!$oldStudentRegister) {
                // $student->leave_date = $oldLeavingDate;
                // $student->status = 1;
                // $student->save();

                DB::rollBack();
                Log::error('trabsfer to old registration error: ');

                return response()->json([
                    'status' => false,
                    'error' => "Student is not transferred from main register to old register",
                ], 402);
            }

            DB::commit();
            Log::error('all thing are good: ');

            return response()->json([
                'status' => true,
                'message' => 'Record deleted successfully',
            ], 200);
        } catch (ValidationException $e) {
            Log::error('validation error: ', $e->getMessage());

            return response()->json([
                'status' => false,
                'errors' => $e->errors(),
            ], 422);
        } catch (Exception $e) {
            Log::error('Somthing Wronge: ', $e->getMessage());

            DB::rollBack();
            return response()->json([
                'status' => false,
                'error' => $e->getMessage(),
            ], 500);
        }
    }

    private function getHostelName()
    {
        try {
            $hostel = BussinessModel::select('businessname')->first();

            return $hostel ? $hostel->businessname : null;
        } catch (Exception $e) {
            Log::error('Error retrieving hostel name: ' . $e->getMessage());
            return null;
        }
    }

    private function insertOrUpdateReviews($studentData, $hostelName, $request)
    {
        try {
            config(['database.default' => env('DB_CONNECTION')]);
            $checkRecords = Reviews::where("hostelname", $hostelName)->where('aadhaar', $studentData->valid);

            $reviewData = [
                "name" => $studentData->candidatename,
                "mobile" => $studentData->phone,
                "email" => $studentData->email,
                "aadhaar" => $studentData->valid,
                "payment_terms" => $request->paymentRating,
                "tenant_behavior" => $request->behaviourRating,
                "responsibilities" => $request->responsibleRating,
                "additional" => $request->AdditionCommant,
                'hostelname' => $hostelName
            ];

            if ($checkRecords->count() > 0) {
                $checkRecords->update($reviewData);
            } else {
                Reviews::create($reviewData);
            }

            config(['database.default' => "custom_db"]);
            return true;
        } catch (Exception $e) {
            config(['database.default' => "custom_db"]);
            Log::error('Error inserting or updating reviews: ' . $e->getMessage());
            throw new Exception('Error inserting or updating reviews');
        }
    }

    private function transferToOldRegister($studentData, $switchDate = null)
    {
        try {
            $oldData = new OldStudentsRegister();
            $oldData->formno = $studentData->formno;
            $oldData->roomno = $studentData->roomno;
            $oldData->seetno = $studentData->seetno;
            $oldData->date = $studentData->join_date != null ? $studentData->join_date : $studentData->date;
            $oldData->candidatename = $studentData->candidatename;
            $oldData->dob = $studentData->dob;
            $oldData->valid = $studentData->valid;
            $oldData->phone = $studentData->phone;
            $oldData->email = $studentData->email;
            $oldData->blood = $studentData->blood;
            $oldData->healthissue = $studentData->healthissue;
            $oldData->health_description = $studentData->health_description;
            $oldData->stydrt = $studentData->stydrt;
            $oldData->vehicalno = $studentData->vehicalno;
            $oldData->vehicledescription = $studentData->vehicledescription;
            $oldData->coursename = $studentData->coursename;
            $oldData->coursedetails = $studentData->coursedetails;
            $oldData->jobdetails = $studentData->jobdetails;
            $oldData->institute = $studentData->institute;
            $oldData->companyname = $studentData->companyname;
            $oldData->institutename = $studentData->institutename;
            $oldData->fathername = $studentData->fathername;
            $oldData->fatheroocc = $studentData->fatheroocc;
            $oldData->mothername = $studentData->mothername;
            $oldData->motheroocc = $studentData->motheroocc;
            $oldData->tel = $studentData->tel;
            $oldData->mobilenumber = $studentData->mobilenumber;
            $oldData->pemail = $studentData->pemail;
            $oldData->fullAddress = $studentData->fullAddress;
            $oldData->state = $studentData->state;
            $oldData->pinno = $studentData->pinno;
            $oldData->guardianname = $studentData->guardianname;
            $oldData->guardiannumber = $studentData->guardiannumber;
            $oldData->guardianaddress = $studentData->guardianaddress;
            $oldData->uploadimage = $studentData->uploadimage;
            $oldData->uploadaadharfront = $studentData->uploadaadharfront;
            $oldData->uploadaadharback = $studentData->uploadaadharback;
            $oldData->leave_date = $switchDate == null ? $studentData->leave_date : $switchDate;
            $oldData->ChangeRoomStatus = $switchDate != null ? 1 : 0;
            $oldData->save();
            return true;
        } catch (Exception $e) {
            Log::error('Error transferring student data to the old student table: ' . $e->getMessage());
            throw new Exception('Error transferring student data to the old student table');
        }
    }


    // 2. room switch (change the room of the student and also add this records to old register table) 

    public function switchRoomMainRegister(Request $request, $studentId)
    {
        try {
            $validator = Validator::make($request->all(), [
                'oldRoomNumber' => 'required',
                'OldSeatNumber' => 'required|numeric',
                'newRoomNumber' => 'required',
                'newSeatNumber' => 'required|numeric',
                'switchDate'   => 'required|date',
            ]);

            if ($validator->fails()) {
                throw new ValidationException($validator);
            }

            // Check if the new room and seat are available
            $checkAvailableRoomAndSeat = StudentRegister::where('roomno', $request->newRoomNumber)
                ->where('seetno', $request->newSeatNumber)
                ->where('status', 1)
                ->count();

            if ($checkAvailableRoomAndSeat > 0) {
                return response()->json([
                    'status' => false,
                    'error' => "The Room number {$request->newRoomNumber} and seat number {$request->newSeatNumber} are not available.",
                ]);
            }

            // Retrieve the student from the main register
            $student = StudentRegister::where('id', $studentId)->where('status', 1)->first();

            if (empty($student)) {
                return response()->json([
                    'status' => false,
                    'error' => "Student not found.",
                ], 404);
            }

            // Transfer the student to the old register
            $oldStudentRegister = $this->transferToOldRegister($student, $request->switchDate);

            // Check if there are any errors in the process
            if (!$oldStudentRegister) {
                return response()->json([
                    'status' => false,
                    'error' => "Failed to transfer student from the main register to the old register.",
                ], 402);
            }

            // Update the main register
            $checkRoomsChanges = $student->ChangeRoom;
            if ($checkRoomsChanges != null) {
                $explodeRooms = explode(",", $checkRoomsChanges);
                $explodeRooms[] = $request->oldRoomNumber;
                $roomsData = implode(',', array_unique($explodeRooms));
                $student->ChangeRoom = $roomsData;
            } else {
                $student->ChangeRoom = $request->oldRoomNumber;
            }

            $student->join_date = $request->switchDate;
            $student->roomno = $request->newRoomNumber;
            $student->seetno = $request->newSeatNumber;
            $student->update();

            return response()->json([
                'status' => true,
                'message' => "Successfully switched room.",
            ]);
        } catch (ValidationException $e) {
            return response()->json([
                'status' => false,
                'errors' => $e->errors(),
            ], 422);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage(),
            ]);
        }
    }
    // Add new Bookin 
    public function addNewBooking(Request $request)
    {
        try {

            //validation

            $validator = Validator::make($request->all(), [
                'name' => 'required|string',
                'mobileNumber' => 'required|numeric|digits:10',
                'bookingDate' => 'required|date',
                'registrationDate' => 'required|date',
                'roomNumber' => 'required',
                'seatNumber' => 'required|numeric',
                'bookingAmount' => 'required|numeric',
            ]);

            if ($validator->fails()) {
                throw new ValidationException($validator);
            }

            // check booking already exists or not at the room and seat number
            $isExist = StudentBooking::where('roomno', $request->roomNumber)
                ->where('seatno', $request->seatNumber)
                ->where('status', 1)
                ->first();

            if (!empty($isExist)) {
                throw new UnexpectedValueException("Student is already registered in the room number {$request->roomNumber} and seat number {$request->seatNumber}.");
            }

            // store booking data into booking table
            StudentBooking::create([
                'candi_name' => $request->name,
                'candidate_mobile' => $request->mobileNumber,
                'booking_date' => $request->bookingDate,
                'regdate' => $request->registrationDate,
                'roomno' => $request->roomNumber,
                'seatno' => $request->seatNumber,
                'Booking_amount' => $request->bookingAmount,
            ]);

            return response()->json([
                'status' => true,
                'message' => "Advance Booking added successfully!"
            ], 200);
        } catch (UnexpectedValueException $e) {
            return response()->json([
                'status' => false,
                'errors' => $e->getMessage(),
            ], 402);
        } catch (ValidationException $e) {
            return response()->json([
                'status' => false,
                'errors' => $e->errors(),
            ], 422);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage()
            ], 500);
        }
    }

    // delete  Booking 

    public function deleteBooking($bookedStudentId)
    {
        try {

            $validator = Validator::make(['id' => $bookedStudentId], [
                'id' => 'required|numeric|exists:bookings,id,status,1',
            ]);

            if ($validator->fails()) {
                throw new ValidationException($validator);
            }

            // check student is exist or not
            $studentInfo = StudentBooking::where("id", $bookedStudentId)->where('status', 1)->first();

            if (empty($studentInfo)) {
                throw new UnexpectedValueException("Student is not found for this id {$bookedStudentId}. ");
            }

            // now change the status 
            $studentInfo->status = 0;
            $studentInfo->update();

            return response()->json([
                'status' => true,
                'message' => "Booking id {$bookedStudentId} is delete successfully."
            ]);
        } catch (ValidationException $e) {
            return response()->json([
                'status' => false,
                'errors' => $e->errors(),
            ], 422);
        } catch (UnexpectedValueException $e) {
            return response()->json([
                'status' => true,
                'error' => $e->getMessage()
            ], 402);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'error' => $e->getMessage()
            ], 500);
        }
    }

    public function getStudentReviews($aadharNo)
    {
        try {
            $reviewData = Reviews::where('aadhaar', $aadharNo)->get();
            return response()->json([
                'status' => true,
                'statusCode' => 200,
                'message' => 'review data',
                'data' => $reviewData,
            ], 200);
        } catch (Exception $e) {
            return response()->json([
                'status' => false,
                'statusCode' => 500,
                'message' => 'server Error',
                'error' => $e->getMessage(),
            ], 500);
        }
    }
}
