<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Database\Eloquent\Model;
use App\Models\LeaveMaster;
use App\Models\LeaveApplication;
use App\Models\TakeAttendance;
use App\Models\EmployeRegister;
use Carbon\Carbon;
use DB;

class AttendanceController extends Controller
{
    public function StoreAttendance(Request $request)
    {
        $empId = session('empId');
        if ($empId == null) {
            return response()->json(["userError" =>"You are not an Employee ."], 500);
        } else {
            $currentTime = Carbon::now()->toTimeString();
            
            $store = new TakeAttendance();
            $store->emp_id - $empId;

        }
    }
    public function Store(Request $request)
    {
        $LeaveTypeTable = new LeaveMaster;
        $LeaveTypeTable->leave_type = $request->leaveName;
        if ($LeaveTypeTable->save()) {
            return back()->with("LeaveSuccess", "Leave Type Inserted Successfully");
        } else {
            return back()->with("LeaveError", "Leave Type is not Inserted!");
        }
    }

    public function leaveApplications()
    {
        dd("LeaveApplication");
    }

    public function LeaveStatusChange(Request $request)
    {
        $Status = $request['leaveStatus'];
        $id = $request["id"];
        $changeStatus = LeaveMaster::where("id", $id)->first();
        if ($changeStatus) {
            if ($Status == 0) {
                $changeStatus->leave_status = 1;
            } else {
                $changeStatus->leave_status = 0;
            }
            if ($changeStatus->update()) {
                return response()->json(["success" => "statusChnage"]);
            }
        } else {
            return response()->json(["error" => "Somthing Wrong"], 500);
        }
    }

    public function DeleteLeaveType(Request $request)
    {
        $id = $request["id"];
        $delete = LeaveMaster::where("id", $id)->first();
        if ($delete->delete()) {
            return response()->json(['success' => "Delete Leave Type"]);
        } else {
            return response()->json(["error" => "not Delete"], 500);
        }
    }

    public function update(Request $request)
    {
        $id = $request->LeaveId;
        $LeaveTypeTable = LeaveMaster::where("id", $id)->first();
        $LeaveTypeTable->leave_type = $request->leaveName;
        if ($LeaveTypeTable->update()) {
            return back()->with("LeaveSuccess", "Leave Type updated Successfully");
        } else {
            return back()->with("LeaveError", "Leave Type is not updated!");
        }
    }
    public function view($id)
    {
        $attendanceData = TakeAttendance::where("emp_id", $id)->get();
        $attendanceEvents = [];
        foreach ($attendanceData as $attendance) {
            $event = [
                'title' => $attendance->status,
                'start' => $attendance->date,
                'time_in' => $attendance->time_in,
                'time_out' => $attendance->time_out,
                'reason' =>$attendance->status === 'Present' ? '' : ($attendance->status === 'Absent' ? $attendance->reason : $attendance->reason),
                'color' => $attendance->status === 'Present' ? 'green' : ($attendance->status === 'Absent' ? 'red' : 'orange'),
            ];
            $attendanceEvents[] = $event;
        }
        // Retrieve the associated employee data
        $employee = null; 

        if ($attendance) {
            config(['database.default' => env('DB_CONNECTION')]);
            $employee = EmployeRegister::find($id);
            config(['database.default' => 'custom_db']);
        }

        // Pass the attendance and employee data, and a flag to indicate if data was found
        return view('fronted.attendance_view', [
            'attendance' => json_encode($attendanceEvents),
            'employee' => $employee,
            'empId' => $id,
            'dataNotFound' => count($attendanceData) === 0
        ]);
    }
}
