<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Response;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\Hash;

class BackupController extends Controller
{
    public function downloadSQL(Request $request)
    {
        // Switch to the "custom" database connection
        $credentials = session("user");
        $hostelName = session("hostel");
        $password = $request->password;
        config(['database.default' => env('DB_CONNECTION')]);
        $admin = DB::table('businessregisters')
            ->where(function ($query) use ($credentials) {
                $query->where('username', $credentials)
                    ->orWhere('username1', $credentials);
            })
            ->where('businessname', $hostelName)
            ->first();

        if (Hash::check($password,$admin->password)) {
            // Fetch table names
            // DB::connection('custom');
            config(['database.default' => 'custom_db']);
            $databaseName = DB::connection()->getDatabaseName();
            $tables = array();
            $result = DB::select("SHOW TABLES");
            foreach ($result as $row) {
                // dd($row);
                $tables[] = $row->{'Tables_in_'.$databaseName};
            }

            // Generate SQL dump for all tables
            $sqlDump = "";
            foreach ($tables as $table) {
                $sqlDump .= $this->generateTableDump($table);
            }

            // Close the "custom" database connection
            // DB::disconnect('custom');
            $backupFileName = $databaseName.'_' . now()->format('Y-m-d_H-i-s') . '.sql'; 
            // Create a download response with the SQL dump content and headers
            return Response::make($sqlDump)
                ->header('Content-Type', 'application/octet-stream')
                ->header('Content-Disposition', 'attachment; filename="' . $backupFileName . '"');
        } else {
            return back()->with("PasswordError", "Your password is incorrect!");
        }
    }

    private function generateTableDump($table)
    {
        // Fetch data from the specified table
        $data = DB::table($table)->get();

        $sqlDump = "DROP TABLE IF EXISTS $table;\n";
        $row2 = DB::select("SHOW CREATE TABLE $table")[0];
        $sqlDump .= $row2->{'Create Table'} . ";\n";

        foreach ($data as $row) {
            $sqlDump .= "INSERT INTO $table VALUES (";
            foreach ($row as $value) {
                $sqlDump .= "'" . addslashes($value) . "',";
            }
            $sqlDump = rtrim($sqlDump, ',');
            $sqlDump .= ");\n";
        }

        $sqlDump .= "\n";

        return $sqlDump;
    }
}
