<?php

namespace App\Http\Controllers;

use App\Models\Olddataregister;
use App\Models\Studentregister;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Intervention\Image\Facades\Image;
use Illuminate\Support\Facades\File;
use App\Models\Reviews;
use Exception;
use Carbon\Carbon;
use App\Models\Salesubscription;
use App\Models\ReferHostel;
use App\Models\ApiModels\StudentLogin;
use App\Models\Sale;
use App\Models\RoomSeat;




class CandidateController extends Controller
{

    public function resizeBase64Image($base64Data, $targetSizeInKB)
    {
        // Decode base64 data
        $img = explode(',', $base64Data);
        // dd($img[1]);

        $imageData = base64_decode($img[1]);


        // Create an image resource from the decoded data
        $img = imagecreatefromstring($imageData);

        // Get the original image dimensions
        $width = imagesx($img);
        $height = imagesy($img);

        // Set the desired width and calculate the corresponding height to maintain the aspect ratio
        $targetWidth = 200; // Adjust this value based on your requirements
        $targetHeight = ($targetWidth / $width) * $height;

        // Create a new image resource for the resized image
        $resizedImg = imagecreatetruecolor($targetWidth, $targetHeight);

        // Resize the image
        imagecopyresampled($resizedImg, $img, 0, 0, 0, 0, $targetWidth, $targetHeight, $width, $height);

        // Create a buffer for the resized image
        ob_start();

        // Output the resized image to the buffer
        imagejpeg($resizedImg, null, 90); // Adjust the quality as needed

        // Get the buffer content
        $resizedImageData = ob_get_clean();

        // Check if the resized image meets the target size
        while (strlen($resizedImageData) > ($targetSizeInKB * 1024)) {
            // If the size is still larger than the target, reduce the quality and update the buffer
            ob_start();
            imagejpeg($resizedImg, null, 90);
            $resizedImageData = ob_get_clean();
        }

        // Encode the resized image to base64
        $resizedBase64Data = base64_encode($resizedImageData);

        // Destroy the image resources
        imagedestroy($img);
        imagedestroy($resizedImg);

        return $resizedBase64Data;
    }

    public function getStudentDetailsForRegister($studentId)
    {
        try {
            $studentData = Studentregister::findOrFail($studentId);
            return response()->json([
                'success' => true,
                'data' => [
                    'registration_date' => $studentData->date,
                    'seat_no' => $studentData->seetno,
                    'room_no' => $studentData->roomno,
                    'form_no' => $studentData->formno,
                    'user_remark' => $studentData->user_remark,
                ],
            ], 200);
        } catch (Exception $e) {
            return response()->json([
                'success' => false,
                'error' => $e->getMessage(),
            ], 404);
        }
    }

    public function ReviewChack(Request $request)
    {
        $aadharNo = $request["aadharValue"];
        config(['database.default' => env('DB_CONNECTION')]);
        $data = Reviews::where("aadhaar", $aadharNo)->get();
        if ($data) {
            $personalInfo = [
                'name' => $data[0]->name,
                'mobile' => $data[0]->mobile,
                'aadhaar' => $data[0]->aadhaar,
                'email' => $data[0]->email
            ];
            $reviewInfo = [];
            foreach ($data as $review) {
                $reviewInfo[] = [
                    'hostelname' => $review->hostelname,
                    'payment_terms' => $review->payment_terms,
                    'tenant_behavior' => $review->tenant_behavior,
                    'responsibilities' => $review->responsibilities,
                    'additional' => $review->additional,
                ];
            }
            return response()->json(['personalInfo' => $personalInfo, 'reviewInfo' => $reviewInfo]);
        } else {
            return response()->json("error", 500);
        }
    }
    public function updateroomnumber(Request $request)
    {
        $StudentFormNo = $request->input('StudentFormNo');
        $changeRoomDate = $request->input("changeRoomDate");
        $data = Studentregister::where("formno", $StudentFormNo)->first();
        if ($data->ChangeRoom != null) {
            $roomsData = explode(",", $data->ChangeRoom);
            $roomsData[] = $request->CurrentRoom;
            $rooms = implode(",", $roomsData);
            $data->ChangeRoom = $rooms;
        } else {
            $data->ChangeRoom = $request->CurrentRoom;
        }

        $olddata = new Olddataregister();
        $olddata->formno = $data->formno;
        $olddata->roomno = $data->roomno;
        $olddata->newRoom = $request->TotalRoom;
        $olddata->seetno = $data->seetno;
        $olddata->date = $data->join_date ? $data->join_date : $data->date;
        $olddata->candidatename = $data->candidatename;
        $olddata->dob = $data->dob;
        $olddata->valid = $data->valid;
        $olddata->phone = $data->phone;
        $olddata->email = $data->email;
        $olddata->blood = $data->blood;
        $olddata->healthissue = $data->healthissue;
        $olddata->health_description = $data->health_description;
        $olddata->stydrt = $data->stydrt;
        $olddata->vehicalno = $data->vehicalno;
        $olddata->vehicledescription = $data->vehicledescription;
        $olddata->coursename = $data->coursename;
        $olddata->coursedetails = $data->coursedetails;
        $olddata->jobdetails = $data->jobdetails;
        $olddata->institute = $data->institute;
        $olddata->companyname = $data->companyname;
        $olddata->institutename = $data->institutename;
        $olddata->fathername = $data->fathername;
        $olddata->fatheroocc = $data->fatheroocc;
        $olddata->mothername = $data->mothername;
        $olddata->motheroocc = $data->motheroocc;
        $olddata->tel = $data->tel;
        $olddata->mobilenumber = $data->mobilenumber;
        $olddata->pemail = $data->pemail;
        $olddata->fullAddress = $data->fullAddress;
        $olddata->state = $data->state;
        $olddata->pinno = $data->pinno;
        $olddata->guardianname = $data->guardianname;
        $olddata->guardiannumber = $data->guardiannumber;
        $olddata->guardianaddress = $data->guardianaddress;
        $olddata->uploadimage = $data->uploadimage;
        $olddata->uploadaadharfront = $data->uploadaadharfront;
        $olddata->uploadaadharback = $data->uploadaadharback;
        $olddata->leave_date = $changeRoomDate;
        $olddata->ChangeRoomStatus = 1;
        if ($olddata->save()) {
            $data->join_date = $changeRoomDate;
            $data->roomno = $request->TotalRoom;
            $data->seetno = $request->selectSeat;
            $data->update();
            return back()->with('RoomUpdate', "Room Updated");
        } else {
            return back()->with('error', 'Something went wrong');
        }
    }
    public function RoomDetils(Request $request)
    {
        $studentId = $request["id"];
        $studetnDetails = Studentregister::where("id", $studentId)
            ->select("roomno", 'seetno', 'formno')->first();
        $RoomNo = $studetnDetails->roomno;
        $seatno = $studetnDetails->seetno;
        $formno = $studetnDetails->formno;
        $TotalRoomNo = DB::table("roomseats")->whereNotIn("roomno", [$RoomNo])->select("roomno")->get();
        if ($TotalRoomNo) {
            foreach ($TotalRoomNo as $room) {
                $rooms[] = $room->roomno;
            }
        }
        return response()->json([
            "id" => $formno,
            "roomNo" => $RoomNo,
            "seatNo" => $seatno,
            "rooms" => $rooms
        ]);
    }
    public function DeleteBookingData(Request $request)
    {
        $BookingId = $request['BookingId'];
        $deleteData = DB::table('bookings')->where('id', $BookingId)
            ->where('status', 1);
        if ($deleteData->update(['status' => 0])) {
            return response()->json(['message' => 'Delete Data']);
        } else {
            return response()->json();
        }
    }
    public function index()
    {
        return view('fronted.index', compact('registrationsByMonth'));
    }
    // public function create()
    // {
    //     //
    // }

    private function checkSeatAvailable(): bool
    {
        try {
            $totalRegister = Studentregister::count();
            config(['database.default' => env('DB_CONNECTION')]);
            $liseneceNo = session("liseneceNo");
            $parchesSeats = Salesubscription::select('no_of_seats')->where("user_id", $liseneceNo)->where("status", 1)->first();
            if (empty($parchesSeats)) {
                config(['database.default' => "custom_db"]);

                return false;
            }
            $message =  ($parchesSeats->no_of_seats) <= $totalRegister ? false : true;
            config(['database.default' => "custom_db"]);

            return $message;
        } catch (Exception $e) {
            return false;
        }
    }

    public function store(Request $request)
    {
        $this->validate(
            $request,
            [
                'formno' => 'required',
                'roomno' => 'required',
                'candidatename' => 'required',
                'dob' => 'required',
                'valid' => 'required|max:12',
                'phone' => 'required|min:10|max:10',
                'email' => 'required|email',
                'stydrt' => 'required',
                'fathername' => 'required',
                'fatheroocc' => 'required',
                'mothername' => 'required',
                'motheroocc' => 'required',
                'tel' => 'required|max:10|min:10',
                'fullAddress' => 'required',
                'state' => 'required',
                'pinno' => 'required|max:6|min:6',
                'guardianname' => 'required',
                'guardiannumber' => 'required',
                'guardianaddress' => 'required',
                'uploadimage' => 'mimes:jpeg,png,jpg',
                'uploadaadharfront' => 'mimes:jpeg,png,jpg',
                'uploadaadharback' => 'mimes:jpeg,png,jpg',
                'blood' => 'required',
                'user_remark' => 'nullable|string',
            ],
            $messages = [
                'required' => 'The attribute field is required.',
                'mimes' => 'Only jpeg, png,jpg are allowed.',
            ]
        );
        $leadid = $request->input('leadid');
        if ($leadid != NULL || $leadid != "") {
            DB::table('leadmanagers')->where('id', $leadid)->update(['leadstatus' => 1]);
        }
        $businessid = $request->input('BusinessID');
        if ($businessid  != NULL || $businessid != "") {
            DB::table('bookings')->where("id", $businessid)->update([
                'status' => 0
            ]);
        }

        // check the subscription seats
        // if (!$this->checkSeatAvailable()) {
        //     return back()->with('error', 'Seat not available for new student register, check your plan.....');
        // }

        $candidateCropImg = $request->uploadCropImg;
        $AadharFrontCrop = $request->AadharFrontCrop;
        $AadharBackCrop = $request->AadharBackCrop;
        $candidatesignCropImg = $request->candidatesignCropImg;
        $ParentCropImg = $request->ParentCropImg;
        $data = new Studentregister();

        $data->formno = $request->formno;
        $data->roomno = $request->roomno;
        $data->seetno = $request->seetno;
        $data->date = $request->date;
        $data->candidatename = $request->candidatename;
        $data->dob = $request->dob;
        $data->valid = $request->valid;
        $data->phone = $request->phone;
        $data->email = $request->email;
        $data->blood = $request->blood;
        $data->healthissue = $request->healthissue;
        $data->health_description = $request->health_description;
        $data->stydrt = $request->stydrt;
        $data->vehicalno = $request->vehicalno;
        $data->vehicledescription = $request->vehicledescription;
        $data->coursename = $request->coursename;
        $data->coursedetails = $request->coursedetails;
        $data->jobdetails = $request->jobdetails;
        $data->institute = $request->institute;
        $data->companyname = $request->companyname;
        $data->institutename = $request->institutename;
        $data->fathername = $request->fathername;
        $data->fatheroocc = $request->fatheroocc;
        $data->mothername = $request->mothername;
        $data->motheroocc = $request->motheroocc;
        $data->tel = $request->tel;
        $data->mobilenumber = $request->mobilenumber;
        $data->pemail = $request->pemail;
        $data->fullAddress = $request->fullAddress;
        $data->state = $request->state;
        $data->pinno = $request->pinno;
        $data->guardianname = $request->guardianname;
        $data->guardiannumber = $request->guardiannumber;
        $data->guardianaddress = $request->guardianaddress;
        $data->referCode = strtoupper($request->referCode);
        $data->user_remark = $request->user_remark;
        if ($request->hasFile('uploadimage')) {
            $file = $request->file('uploadimage');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;
            $resizedBase64Data = $this->resizeBase64Image($candidateCropImg, 50);
            File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
            $data->uploadimage = $filename;
        }
        if ($request->hasFile('uploadaadharfront')) {
            $file = $request->file('uploadaadharfront');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $resizedBase64Data = $this->resizeBase64Image($AadharFrontCrop, 50);
            File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
            $data->uploadaadharfront = $filename;
        }
        if ($request->hasFile('uploadaadharback')) {
            $file = $request->file('uploadaadharback');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $resizedBase64Data = $this->resizeBase64Image($AadharBackCrop, 50);
            File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
            $data->uploadaadharback = $filename;
        }
        if ($request->hasFile('candidatesign')) {
            $file = $request->file('candidatesign');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $resizedBase64Data = $this->resizeBase64Image($candidatesignCropImg, 50);
            File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
            $data->candidatesign = $filename;
        }
        if ($request->hasFile('Parentsign')) {
            $file = $request->file('Parentsign');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $resizedBase64Data = $this->resizeBase64Image($ParentCropImg, 50);
            File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
            $data->Parentsign = $filename;
        }
        $data->save();
        if ($request->referCode != "") {
            ReferHostel::updateReferralDiscounts($data->id, strtoupper($request->referCode));
        }
        if ($businessid  != NULL || $businessid != "") {
            return back()->with('BookingSaved', 'Registration Successful');
        } else if ($leadid != NULL || $leadid != "") {
            return back()->with('leadSaved', 'Registration Successful');
        } else {
            return back()->with('RegistrationSuccess', 'Registration Successful');
        }
    }
    public function edit($id)
    {
        $datas = Studentregister::find($id);
        return view('fronted.editregister', compact('datas'));
    }
    public function update(Request $request, $id)
    {
        // deleteimgs 
        $candidateImg = "";
        $candidateSingImg = "";
        $parentSingImg = "";
        $aadharFrountImg = "";
        $aadharBackImg = "";

        $deleteImg = Studentregister::where("id", $id)
            ->select('uploadimage', 'candidatesign', 'Parentsign', 'uploadaadharfront', 'uploadaadharback')->first();
        $data = Studentregister::find($id);
        $healthCheck = $request->healthCheck;
        $vehicalCheck = $request->VehicalCheck;
        $coursetype = $request->coursetype;
        $uploadCropImg = $request->uploadCropImg;
        $parentCropSing = $request->ParentCropImg;
        $candidateCropSing = $request->candidatesignCropImg;
        $candidateAadharFrontCrop = $request->AadharFrontCrop;
        $candidateAadharBackCrop = $request->AadharFrontBackCrop;
        if ($healthCheck == 'yes') {
            $health_description =  $request->healthissue;
        } else {
            $health_description = "";
        }
        if ($vehicalCheck == 'yes') {
            $vehicledescription =  $request->vehicalno;
        } else {
            $vehicledescription = "";
        }
        if ($coursetype == "coursetype") {
            $courseName = $request->coursename;
            $jobName = "";
        } else {
            $jobName = $request->coursename;
            $courseName = "";
        }
        // $data->formno = $request->formno;
        $data->roomno = $request->roomno;
        $data->seetno = $request->seetno;
        $data->date = $request->date;
        $data->candidatename = $request->candidatename;
        $data->dob = $request->dob;
        $data->valid = $request->valid;
        $data->phone = $request->phone;
        $data->email = $request->email;
        $data->blood = $request->blood;
        $data->healthissue = $healthCheck;
        $data->health_description =  $health_description;
        $data->stydrt = $request->stydrt;
        $data->vehicalno = $vehicalCheck;
        $data->vehicledescription = $vehicledescription;
        $data->coursedetails = $courseName;
        $data->jobdetails = $jobName;
        $data->institutename = $request->institutename;
        $data->fathername = $request->fathername;
        $data->fatheroocc = $request->fatheroocc;
        $data->mothername = $request->mothername;
        $data->motheroocc = $request->motheroocc;
        $data->tel = $request->tel;
        $data->mobilenumber = $request->mobilenumber;
        $data->pemail = $request->pemail;
        $data->fullAddress = $request->fullAddress;
        $data->state = $request->state;
        $data->pinno = $request->pinno;
        $data->guardianname = $request->guardianname;
        $data->guardiannumber = $request->guardiannumber;
        $data->guardianaddress = $request->guardianaddress;
        $data->user_remark = $request->user_remark;
        if ($request->hasFile('uploadimage')) {
            $file = $request->file('uploadimage');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;
            $candidateImg = $filename;
            if ($uploadCropImg != "" || $uploadCropImg != null) {
                $resizedBase64Data = $this->resizeBase64Image($uploadCropImg, 50);
                File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
                $imagePath = public_path('assets/uploads/' . $deleteImg->uploadimage);
                $data->uploadimage = $filename;
                File::delete($imagePath);
            } else {
                if ($file->move(sys_get_temp_dir(), $filename)) {
                    $filePath = sys_get_temp_dir() . '/' . $filename;
                    // Check if the file exists and get the size
                    if (file_exists($filePath)) {
                        $fileSize = filesize($filePath);
                        // Check if the file size exceeds the limit
                        if ($fileSize > 1600 * 1024) {
                            // Compress the image
                            $image = imagecreatefromstring(file_get_contents($filePath));
                            $compressedImage = imagecreatetruecolor(imagesx($image), imagesy($image));
                            imagecopyresampled($compressedImage, $image, 0, 0, 0, 0, imagesx($image), imagesy($image), imagesx($image), imagesy($image));
                            imagejpeg($compressedImage, $filePath, 75); // Compress with 75% quality
                            // Free up memory
                            imagedestroy($image);
                            imagedestroy($compressedImage);
                        }
                        // Move the file to the final destination
                        if (rename($filePath, 'assets/uploads/' . $filename)) {
                            $imagePath = public_path('assets/uploads/' . $deleteImg->uploadimage);
                            $data->uploadimage = $filename;
                            File::delete($imagePath);
                        } else {
                            // Error moving file to the final destination
                            return back()->with('error', 'The file could not be moved to the destination.');
                        }
                    } else {
                        // Error getting file size
                        return back()->with('error', 'Error getting file size.');
                    }
                } else {
                    // Error moving file to the temporary location
                    return back()->with('error', 'The file could not be moved to the temporary location.');
                }
            }
            // Move the file to a temporary location
        }
        if ($request->hasFile('candidatesign')) {
            $file = $request->file('candidatesign');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $candidateSingImg = $filename;
            if ($candidateCropSing != "" || $candidateCropSing != null) {

                $resizedBase64Data = $this->resizeBase64Image($candidateCropSing, 50);
                File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
                $data->candidatesign = $filename;

                $candidatesign = public_path('assets/uploads/' . $deleteImg->candidatesign);
                File::delete($candidatesign);
            } else {
                // Move the file to a temporary location
                if ($file->move(sys_get_temp_dir(), $filename)) {
                    $filePath = sys_get_temp_dir() . '/' . $filename;
                    // Check if the file exists and get the size
                    if (file_exists($filePath)) {
                        $fileSize = filesize($filePath);
                        // Check if the file size exceeds the limit
                        if ($fileSize > 1600 * 1024) {
                            // Compress the image
                            $image = imagecreatefromstring(file_get_contents($filePath));
                            $compressedImage = imagecreatetruecolor(imagesx($image), imagesy($image));
                            imagecopyresampled($compressedImage, $image, 0, 0, 0, 0, imagesx($image), imagesy($image), imagesx($image), imagesy($image));
                            imagejpeg($compressedImage, $filePath, 75); // Compress with 75% quality
                            // Free up memory
                            imagedestroy($image);
                            imagedestroy($compressedImage);
                        }
                        // Move the file to the final destination
                        if (rename($filePath, 'assets/uploads/' . $filename)) {
                            $data->candidatesign = $filename;
                            $candidatesign = public_path('assets/uploads/' . $deleteImg->candidatesign);
                            File::delete($candidatesign);
                        } else {
                            // Error moving file to the final destination
                            return back()->with('error', 'The file could not be moved to the destination.');
                        }
                    } else {
                        // Error getting file size
                        return back()->with('error', 'Error getting file size.');
                    }
                } else {
                    // Error moving file to the temporary location
                    return back()->with('error', 'The file could not be moved to the temporary location.');
                }
            }
        }
        if ($request->hasFile('Parentsign')) {
            $file = $request->file('Parentsign');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $parentSingImg = $filename;
            if ($parentCropSing != "" || $parentCropSing != null) {
                $resizedBase64Data = $this->resizeBase64Image($parentCropSing, 50);
                File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
                $data->Parentsign = $filename;
                $Parentsign = public_path('assets/uploads/' . $deleteImg->Parentsign);
                File::delete($Parentsign);
            } else {
                if ($file->move(sys_get_temp_dir(), $filename)) {
                    $filePath = sys_get_temp_dir() . '/' . $filename;
                    // Check if the file exists and get the size
                    if (file_exists($filePath)) {
                        $fileSize = filesize($filePath);
                        // Check if the file size exceeds the limit
                        if ($fileSize > 1600 * 1024) {
                            // Compress the image
                            $image = imagecreatefromstring(file_get_contents($filePath));
                            $compressedImage = imagecreatetruecolor(imagesx($image), imagesy($image));
                            imagecopyresampled($compressedImage, $image, 0, 0, 0, 0, imagesx($image), imagesy($image), imagesx($image), imagesy($image));
                            imagejpeg($compressedImage, $filePath, 75); // Compress with 75% quality
                            // Free up memory
                            imagedestroy($image);
                            imagedestroy($compressedImage);
                        }
                        // Move the file to the final destination
                        if (rename($filePath, 'assets/uploads/' . $filename)) {
                            $data->Parentsign = $filename;
                            $Parentsign = public_path('assets/uploads/' . $deleteImg->Parentsign);
                            File::delete($Parentsign);
                        } else {
                            // Error moving file to the final destination
                            return back()->with('error', 'The file could not be moved to the destination.');
                        }
                    } else {
                        // Error getting file size
                        return back()->with('error', 'Error getting file size.');
                    }
                } else {
                    // Error moving file to the temporary location
                    return back()->with('error', 'The file could not be moved to the temporary location.');
                }
            }
        }
        if ($request->hasFile('uploadaadharfront')) {
            $file = $request->file('uploadaadharfront');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $aadharFrountImg = $filename;
            if ($candidateAadharFrontCrop != "" || $candidateAadharFrontCrop != null) {
                $resizedBase64Data = $this->resizeBase64Image($candidateAadharFrontCrop, 50);
                File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));
                $data->uploadaadharfront = $filename;
                $uploadaadharfront = public_path('assets/uploads/' . $deleteImg->uploadaadharfront);
                File::delete($uploadaadharfront);
            } else {
                if ($file->move(sys_get_temp_dir(), $filename)) {
                    $filePath = sys_get_temp_dir() . '/' . $filename;
                    // Check if the file exists and get the size
                    if (file_exists($filePath)) {
                        $fileSize = filesize($filePath);
                        // Check if the file size exceeds the limit
                        if ($fileSize > 1600 * 1024) {
                            // Compress the image
                            $image = imagecreatefromstring(file_get_contents($filePath));
                            $compressedImage = imagecreatetruecolor(imagesx($image), imagesy($image));
                            imagecopyresampled($compressedImage, $image, 0, 0, 0, 0, imagesx($image), imagesy($image), imagesx($image), imagesy($image));
                            imagejpeg($compressedImage, $filePath, 75); // Compress with 75% quality
                            // Free up memory
                            imagedestroy($image);
                            imagedestroy($compressedImage);
                        }
                        // Move the file to the final destination
                        if (rename($filePath, 'assets/uploads/' . $filename)) {
                            $data->uploadaadharfront = $filename;
                            $uploadaadharfront = public_path('assets/uploads/' . $deleteImg->uploadaadharfront);
                            File::delete($uploadaadharfront);
                        } else {
                            // Error moving file to the final destination
                            return back()->with('error', 'The file could not be moved to the destination.');
                        }
                    } else {
                        // Error getting file size
                        return back()->with('error', 'Error getting file size.');
                    }
                } else {
                    // Error moving file to the temporary location
                    return back()->with('error', 'The file could not be moved to the temporary location.');
                }
            }
        }
        if ($request->hasFile('uploadaadharback')) {
            $file = $request->file('uploadaadharback');
            $extension = $file->getClientOriginalExtension();
            $filename = str_replace(' ', '_', $request->candidatename) . '_' . Carbon::now()->format("YmdHis") . '_' . uniqid() . '.' . $extension;

            $aadharBackImg = $filename;
            if ($candidateAadharBackCrop != "" || $candidateAadharBackCrop != null) {

                $resizedBase64Data = $this->resizeBase64Image($candidateAadharBackCrop, 50);
                File::put(public_path('assets/uploads/' . $filename), base64_decode($resizedBase64Data));

                $data->uploadaadharback = $filename;
                $uploadaadharback = public_path('assets/uploads/' . $deleteImg->uploadaadharback);
                File::delete($uploadaadharback);
            } else {
                if ($file->move(sys_get_temp_dir(), $filename)) {
                    $filePath = sys_get_temp_dir() . '/' . $filename;
                    // Check if the file exists and get the size
                    if (file_exists($filePath)) {
                        $fileSize = filesize($filePath);
                        // Check if the file size exceeds the limit
                        if ($fileSize > 1600 * 1024) {
                            // Compress the image
                            $image = imagecreatefromstring(file_get_contents($filePath));
                            $compressedImage = imagecreatetruecolor(imagesx($image), imagesy($image));
                            imagecopyresampled($compressedImage, $image, 0, 0, 0, 0, imagesx($image), imagesy($image), imagesx($image), imagesy($image));
                            imagejpeg($compressedImage, $filePath, 75); // Compress with 75% quality
                            // Free up memory
                            imagedestroy($image);
                            imagedestroy($compressedImage);
                        }
                        // Move the file to the final destination
                        if (rename($filePath, 'assets/uploads/' . $filename)) {
                            $data->uploadaadharback = $filename;
                            $uploadaadharback = public_path('assets/uploads/' . $deleteImg->uploadaadharback);
                            File::delete($uploadaadharback);
                        } else {
                            // Error moving file to the final destination
                            return back()->with('error', 'The file could not be moved to the destination.');
                        }
                    } else {
                        // Error getting file size
                        return back()->with('error', 'Error getting file size.');
                    }
                } else {
                    // Error moving file to the temporary location
                    return back()->with('error', 'The file could not be moved to the temporary location.');
                }
            }
        }
        if ($data->update()) {
            $formno = $deleteImg->formno;
            $allRecords = Olddataregister::where("formno", $formno)->get();
            foreach ($allRecords as $record) {
                $record->update([
                    'candidatename' => $request->candidatename,
                    'dob' => $request->dob,
                    'valid' => $request->valid,
                    'phone' => $request->phone,
                    'email' => $request->email,
                    'blood' => $request->blood,
                    'healthissue' => $healthCheck,
                    'health_description' => $health_description,
                    'stydrt' => $request->stydrt,
                    'vehicalno' => $vehicalCheck,
                    'vehicledescription' => $vehicledescription,
                    'coursedetails' => $courseName,
                    'jobdetails' => $jobName,
                    'institutename' => $request->institutename,
                    'fathername' => $request->fathername,
                    'fatheroocc' => $request->fatheroocc,
                    'mothername' => $request->mothername,
                    'motheroocc' => $request->motheroocc,
                    'tel' => $request->tel,
                    'mobilenumber' => $request->mobilenumber,
                    'pemail' => $request->pemail,
                    'fullAddress' => $request->fullAddress,
                    'state' => $request->state,
                    'pinno' => $request->pinno,
                    'guardianname' => $request->guardianname,
                    'guardiannumber' => $request->guardiannumber,
                    'guardianaddress' => $request->guardianaddress,
                    'uploadimage' => $candidateImg,
                    'candidatesign' => $candidateSingImg,
                    'Parentsign' => $parentSingImg,
                    'uploadaadharfront' => $aadharFrountImg,
                    'uploadaadharback' => $aadharBackImg,
                ]);
            }
            return back()->with('StudentRegisterSuccess', 'Registration Updated Successfully');
        } else {
            return back()->with('error', 'Not Update!');
        }
        // File::delete(public_path('storage/'.$post->image))
    }
    public function destroy($id)
    {
        $data = Olddataregister::find($id);
        $oldRoomNo = $data->roomno;
        $oldSeatNo = $data->seetno;
        $formno = $data->formno;
        // check this roomno and seatno avaible or not
        $checkRecords = Studentregister::where('roomno', $oldRoomNo)->where('seetno', $oldSeatNo)->where('status', 1)->first();
        if ($checkRecords) {
            return back()->with('error', 'previous room number and seat number is not available');
        }
        $updateRecord = Studentregister::where('formno', $formno)->first();

        $updateRecord->roomno = $oldRoomNo;
        $updateRecord->seetno = $oldSeatNo;
        if ($updateRecord->join_date === $data->date) {
            $updateRecord->join_date = null;
        } else {
            $updateRecord->join_date = $data->date;
        }
        $updateRecord->update();
        $data->delete();
        return back()->with('danger', 'Old data registeration deleted!');
    }
    public function leavingdateupdate(Request $request)
    {
        $leavingDate = $request->input('leave_date');
        $rate1 = $request->input("payment_terms_rating");
        $rate2 = $request->input("tenant_behavior_rating");
        $rate3 = $request->input("responsibilities_rating");
        $additional_comments = $request->input("additional_comments");
        $studentID = $request->input('studentID');

        DB::table('studentregisters')
            ->where('id', $studentID)
            ->update([
                'leave_date' => $leavingDate,
                'status' => 0,
            ]);
        $data = Studentregister::find($studentID);
        $hostelName = session("hostel");
        config(['database.default' => env('DB_CONNECTION')]);
        $checkStudent = Reviews::where("hostelname", $hostelName)->where('aadhaar', $data->valid);
        if ($checkStudent->count() > 0) {
            $Reviews = Reviews::where("hostelname", $hostelName)->first();
            $Reviews->name = $data->candidatename;
            $Reviews->mobile = $data->phone;
            $Reviews->email = $data->email;
            $Reviews->aadhaar = $data->valid;
            $Reviews->payment_terms = $rate1;
            $Reviews->tenant_behavior = $rate2;
            $Reviews->responsibilities = $rate3;
            $Reviews->additional = $additional_comments;
            $Reviews->hostelname = session("hostel");
            $Reviews->update();
        } else {
            $Reviews = new Reviews();
            $Reviews->name = $data->candidatename;
            $Reviews->mobile = $data->phone;
            $Reviews->email = $data->email;
            $Reviews->aadhaar = $data->valid;
            $Reviews->payment_terms = $rate1;
            $Reviews->tenant_behavior = $rate2;
            $Reviews->responsibilities = $rate3;
            $Reviews->additional = $additional_comments;
            $Reviews->hostelname = session("hostel");
            $Reviews->save();
        }
        config(['database.default' => "custom_db"]);
        $olddata = new Olddataregister();
        $olddata->formno = $data->formno;
        $olddata->roomno = $data->roomno;
        $olddata->seetno = $data->seetno;
        $olddata->date = $data->join_date != null ? $data->join_date : $data->date;
        $olddata->candidatename = $data->candidatename;
        $olddata->dob = $data->dob;
        $olddata->valid = $data->valid;
        $olddata->phone = $data->phone;
        $olddata->email = $data->email;
        $olddata->blood = $data->blood;
        $olddata->healthissue = $data->healthissue;
        $olddata->health_description = $data->health_description;
        $olddata->stydrt = $data->stydrt;
        $olddata->vehicalno = $data->vehicalno;
        $olddata->vehicledescription = $data->vehicledescription;
        $olddata->coursename = $data->coursename;
        $olddata->coursedetails = $data->coursedetails;
        $olddata->jobdetails = $data->jobdetails;
        $olddata->institute = $data->institute;
        $olddata->companyname = $data->companyname;
        $olddata->institutename = $data->institutename;
        $olddata->fathername = $data->fathername;
        $olddata->fatheroocc = $data->fatheroocc;
        $olddata->mothername = $data->mothername;
        $olddata->motheroocc = $data->motheroocc;
        $olddata->tel = $data->tel;
        $olddata->mobilenumber = $data->mobilenumber;
        $olddata->pemail = $data->pemail;
        $olddata->fullAddress = $data->fullAddress;
        $olddata->state = $data->state;
        $olddata->pinno = $data->pinno;
        $olddata->guardianname = $data->guardianname;
        $olddata->guardiannumber = $data->guardiannumber;
        $olddata->guardianaddress = $data->guardianaddress;
        $olddata->uploadimage = $data->uploadimage;
        $olddata->uploadaadharfront = $data->uploadaadharfront;
        $olddata->uploadaadharback = $data->uploadaadharback;
        $olddata->leave_date = $data->leave_date;
        $olddata->save();

        // change this student data in studentLoginTable.
        $loginStudentData =  StudentLogin::where('mobile_no', $data->phone)
            ->where('hostel_id', session("liseneceNo"))
            ->first();

        if (!empty($loginStudentData)) {
            $loginStudentData->update([
                'is_active_in_hostel' => 2 // student not active now
            ]);
        }


        return back()->with('warning', 'Register Transfer to old Register ');
    }
    public function updatestudent(Request $request, $id)
    {
        // $leavingDate = $request->input('date');
        $studentID = $request->input('formno');
        // DB::table('studentregisters')
        //     ->where('formno', $studentID)
        //     ->update([
        //         'leave_date' => $leavingDate,
        //         'status' => 1,
        //     ]);
        $data = Studentregister::where("formno", $studentID)->first();
        // dd($data);
        $data->roomno = $request->roomno;
        $data->seetno = $request->seetno;
        $data->join_date = $request->date;
        $data->leave_date = null;
        $data->status = 1;
        $data->update();
        // change this student data in studentLoginTable.
        $loginStudentData =  StudentLogin::where('mobile_no', $data->phone)
            ->where('hostel_id', session("liseneceNo"))
            ->first();

        if (!empty($loginStudentData)) {
            $loginStudentData->update([
                'is_active_in_hostel' => 1 // student not active now
            ]);
        }

        return back()->with('success', 'Old data Retrieve');
    }

    public function oldStudentView()
    {
        $oldStudentData = Olddataregister::orderBy('leave_date', 'desc')->get();
        $totalRegistrations = Studentregister::count('id');
        $runningRegistrations = Studentregister::where('status', 1)->count('id');
        $oldRegistrations = Studentregister::where('status', 0)->count('id');
        $totalSeats = RoomSeat::sum('numberseats');
        $totalVacantSeats = $totalSeats - $runningRegistrations;
        return view('fronted.oldregistration', compact('oldStudentData', 'totalRegistrations', 'runningRegistrations', 'oldRegistrations', 'totalVacantSeats'));
    }
}
