<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use Carbon\Carbon;
use Exception;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Support\Facades\Log;
use App\Models\Item;
use App\Models\Customsalesale;
use App\Models\MessageManager;
use App\Models\RoomSeat;
use App\Models\ClientPartyTableForCustomeSale;

class CustomSaleController extends Controller
{
    public function createNewPart(Request $request)
    {
        try {
            // Validate input data
            $validatedData = $request->validate([
                'party_name' => 'required|string|max:50',
                'party_mobile' => 'required|digits:10',
                'party_email' => 'required|email',
                'party_address' => 'required|string|max:255',
            ]);

            // Create a new record in the ClientPartyTableForCustomeSale table
            ClientPartyTableForCustomeSale::create([
                'party_name' => $validatedData['party_name'],
                'mobile' => $validatedData['party_mobile'],
                'email' => $validatedData['party_email'],
                'address' => $validatedData['party_address'],
            ]);

            // Redirect with success message
            return redirect()->route('sale.view')->with('success', 'New party created successfully!');
        } catch (Exception $e) {
            // Handle exception and redirect back with error message
            return redirect()->back()->withErrors('An error occurred while creating the party. Please try again.');
        }
    }
}
