<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\CustomSaleTermsConditions;
use Exception;
use Illuminate\Support\Facades\Validator;
use UnexpectedValueException;
use Illuminate\Database\Eloquent\ModelNotFoundException;


class CustomSaleTermsConditionsController extends Controller
{
    public function store(Request $request)
    {
        try {
            $validator = Validator::make($request->all(), [
                'termsAndCondition' => 'required|string',
            ]);
            if ($validator->fails()) {
                return back()->with('error', 'Please fill terms And Conditions input fields.');
            }
            CustomSaleTermsConditions::create([
                "termandconditions" => $request->input("termsAndCondition")
            ]);
            return back()->with('success', 'custom sale terms and condition has been added successfully!');
        } catch (UnexpectedValueException $e) {
            return back()->with('error', $e->getMessage());
        } catch (Exception $e) {
            return back()->with('error', $e->getMessage());
        }
    }

    public function delete($id)
    {
        try {
            $termAndCondition = CustomSaleTermsConditions::findOrfail($id);
            $termAndCondition->delete();
            return back()->with('success', 'Data deleted Successfully');
        } catch (ModuleNotFoundException $e) {
            return back()->with('error', $e->getMessage());
        } catch (Exception $e) {
            return back()->with('error', $e->getMessage());
        }
    }
}
