<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use Illuminate\Support\Carbon;
use Exception;
use App\Models\RoomSeat;
use App\Models\ReserveRoom;
use App\Models\ElectricityManagement;
use App\Models\Studentregister;

class ElectricityBillGenrater extends Controller
{
    private function CheckLeftStudents($roomno, $selectedMonth)
    {
        $studentData = [];
        $student_count = Studentregister::where('roomNo', $roomno)
            ->where('status', 0)
            ->where(DB::raw('Month(leave_date)'), '=', $selectedMonth)
            ->get();
        if (!empty($student_count)) {
            foreach ($student_count as $student) {
                $students[] = [
                    "name" => $student->candidatename,
                    "joinDate" => $student->date,
                    "leaveDate" => $student->leave_date,
                    'seatNo' => $student->seetno,
                ];
                $studentData = $students;
            }
        }
        return $studentData;
    }
    private function CaluculateBillForLeftStudents($roomno, $units, $prUnitRate, $selectedMonth)
    {
        $currentYear = now()->year;
        $completeDateString = $currentYear . '-' . $selectedMonth . '-01';
        $studentRecords = Studentregister::where('roomNo', $roomno)
            ->orderBy("date", "Asc")
            ->get();
        $data = [];
        if(!empty($studentRecords)){
            foreach($studentRecords as $key => $students){
                $leftDate = $students->leave_date;
                $joinDate = $students->data;
                $joinDateMonth = Carbon::parse($joinDate)->format("m");
                if($leftDate != null){
                    $leftDateMonth = Carbon::parse($leftDate)->format("m");
                }else{
                    $leftDateMonth = '';
                }
             
                if( $joinDate === $selectedMonth || $leftDateMonth === $selectedMonth || $leftDateMonth = ""){
                    $data[$key]= [
                        "name"=>$students->candidatename,
                        "joinDate"=>$students->date,
                        'leftDate'=>$students->leave_date,
                        'roomno'=>$students->roomno
                    ];
                }
            }
        }
        dd($data);
        $selectedMonthStartDate = Carbon::parse($completeDateString)->startOfMonth();
        $selectedMonthEndDate = Carbon::parse($completeDateString)->endOfMonth();

        $oldStudents = $this->CheckOldStudents($roomno, $selectedMonth);
        $newStudents = $this->CheckNewStudents($roomno, $selectedMonth);
        $leftStudents = $this->CheckLeftStudents($roomno, $selectedMonth);
        $noOfOldStudents = count($oldStudents);
        $noOfNewStudents = count($newStudents);
        $NoOfLeftStudents = count($leftStudents);
        $totalDaysInMonth = $selectedMonthEndDate->day;
        $perDayUnit = $units / $totalDaysInMonth;
        $newStudentBill = [];
        $oldStudentBills = [];
        if (count($newStudents) > 0) {
            $newStudentBill = $this->CalculateBillForNewStudents($newStudents, $units, $prUnitRate);
        }
        if (count($oldStudents) > 0) {
            $oldStudentBills = $this->CalculateBillForOldStudents($oldStudents, $units, $prUnitRate);
        }
        $leftStudentBill = [];
        if (!empty($leftStudents)) {
            for ($i = 0; $i < $NoOfLeftStudents; $i++) {
                $diffInDays = Carbon::parse($selectedMonthStartDate)->diffInDays(Carbon::parse($leftStudents[$i]['leaveDate']));
                $bills = ($diffInDays * $perDayUnit) / ($i + 1);
                array_push($leftStudentBill, $bills);
            }
        }

        foreach ($leftStudents as $key => $student) {
            $leftStudents[$key]['TotalUnit'] = $leftStudentBill[$key]; // Assuming $leftStudentBill is an array
            $leftStudents[$key]['TotalAmount'] = $leftStudentBill[$key] * $prUnitRate;
        }

        dd($leftStudents, $newStudentBill, $oldStudentBills);
        // return $leftStudentBill;

    }

    private function CheckOldStudents($roomno, $selectedMonth)
    {
        $studentData =  [];
        $totalDaysInMonth = now()->endOfMonth()->day;
        $student_records = Studentregister::where('roomno', $roomno)
            ->where('status', 1)
            ->get();
        if (!$student_records->isEmpty()) {
            foreach ($student_records as $student) {
                $checkOldStudents = Carbon::parse($student->date);
                if ($checkOldStudents->format("m") !== $selectedMonth) {
                    $Students[] = [
                        "name" => $student->candidatename,
                        "joinDate" => $student->date,
                        'seatNo' => $student->seetno,
                        'leaveDate' => $student->leave_date
                    ];
                    $studentData = $Students;
                }
            }
        }

        return $studentData;
    }
    private function CalculateBillForOldStudents($oldStudents, $units, $perUniteRate)
    {
        $studentData =  $oldStudents;
        $totalDaysInMonth = now()->endOfMonth()->day;
        $perDayUnit = $units / $totalDaysInMonth;
        $currentMonth = Carbon::now()->format('m');

        $totalOldStudent = count($oldStudents);
        for ($i = 0; $i < $totalOldStudent; $i++) {
            $studentUnit = ($perDayUnit * $totalDaysInMonth) / $totalOldStudent;
            $studentData[$i]["TotalUnit"] = round($studentUnit, 2);
            $studentData[$i]["TotalAmount"] = round(($studentUnit * $perUniteRate), 2);
        }
        return $studentData;
    }
    private function CheckNewStudents($roomNo, $selectedMonth)
    {
        $studentRecords = [];
        $currentMonthStartDate = now()->startOfMonth();
        $currentMonthEndDate = now()->endOfMonth(); // Assuming you want the start of the current month
        $student_records = Studentregister::where('roomno', $roomNo)
            ->where('status', 1)
            ->where(DB::raw('Month(date)'), '=', $selectedMonth)
            ->orderBy('date', 'ASC')
            ->get();
        if (!$student_records->isEmpty()) {
            foreach ($student_records as $student) {
                $seatno = $student->seetno;
                $joiningData = [
                    'seatNo' => $seatno,
                    "name" => $student->candidatename,
                    "joinDate" => $student->date,
                    "leaveDate" => $student->leave_date
                ];
                $studentRecords[] = $joiningData;
            }
        }
        return $studentRecords;
    }

    private function CalculateBillForNewStudents($newStudentsRecord, $units, $prUnitRate)
    {
        $noOfNewStudents = count($newStudentsRecord);
        $TotalUnit = $units;
        $lastDateOfMonth = now()->endOfMonth();
        $totalDaysInMonth = now()->endOfMonth()->day;
        $perDayUnit = $TotalUnit / $totalDaysInMonth;
        $studentsBills = [];
        $totalDays = 0;
        $diffDaysArray = [];

        for ($i = 0; $i < $noOfNewStudents - 1; $i++) { //3 
            $firstStudentJoinDate = $newStudentsRecord[$i]["joinDate"];
            $secondStudentJoinDate = $newStudentsRecord[$i + 1]['joinDate'];
            $diffInDays = Carbon::parse($secondStudentJoinDate)->diffInDays(Carbon::parse($firstStudentJoinDate));
            if ($i === 0) {
                $diffInDays += 1;
            }
            array_push($diffDaysArray, $diffInDays);
            $bill = $diffInDays * ($perDayUnit / ($i + 1));
            $totalDays += $diffInDays;
            $bill = round($bill, 2);

            if (!empty($studentsBills)) {
                for ($j = 0; $j < count($studentsBills); $j++) {
                    $studentsBills[$j] += $bill;
                }
            }
            array_push($studentsBills, $bill);
        }

        // Handling the last student
        // dd($studentsBills);
        $lastStudentJoinDate = $newStudentsRecord[$noOfNewStudents - 1]['joinDate'];
        $lastStudentDays = Carbon::parse($lastDateOfMonth)->diffInDays(Carbon::parse($lastStudentJoinDate));
        $bill = $lastStudentDays * $perDayUnit;
        $bill = round(($bill / $noOfNewStudents), 2);
        $totalDays += $lastStudentDays;
        array_push($diffDaysArray, $lastStudentDays);

        if (!empty($studentsBills)) {
            for ($j = 0; $j < count($studentsBills); $j++) {
                $studentsBills[$j] += $bill;
            }
        }
        array_push($studentsBills, $bill);
        for ($k = 0; $k < $noOfNewStudents; $k++) {
            $newStudentsRecord[$k]['TotalUnit'] = $studentsBills[$k];
            $newStudentsRecord[$k]['TotalAmount'] = round(($studentsBills[$k] * $prUnitRate), 2);
        }
        return $newStudentsRecord;
    }

    private function calculateBillForNewAndOldStudents($roomno, $units, $prUnitRate, $selectedMonth)
    {

        $oldStudents = $this->CheckOldStudents($roomno, $selectedMonth);
        $NewStudents = $this->CheckNewStudents($roomno, $selectedMonth);
        $noOfOldStudens = count($oldStudents);
        $noOfNewStudents = count($NewStudents);
        $lastDateOfMonth = now()->endOfMonth();
        $currentMonthStartDate = now()->startOfMonth();

        $totalDaysInMonth = now()->endOfMonth()->day;
        $perDayUnit = $units / $totalDaysInMonth;
        $newStudentBill = [];
        $oldStudentBills = [];
        if ($noOfNewStudents !== 0) {
            for ($i = 0; $i < $noOfNewStudents - 1; $i++) {
                $firstStudentJoinDate = $NewStudents[$i]["joinDate"];
                $secondStudentJoinDate = $NewStudents[$i + 1]['joinDate'];
                $diffInDays = Carbon::parse($secondStudentJoinDate)->diffInDays(Carbon::parse($firstStudentJoinDate));
                if ($i === 0) {
                    $diffInDays += 1;
                }
                $bill = $diffInDays * ($perDayUnit / ($i + 1 + $noOfOldStudens));
                $bill = round($bill, 2);

                if (!empty($newStudentBill)) {
                    for ($j = 0; $j < count($newStudentBill); $j++) {
                        $newStudentBill[$j] += $bill;
                    }
                }
                array_push($newStudentBill, $bill);
            }
            // Handling the last student
            $lastStudentJoinDate = $NewStudents[$noOfNewStudents - 1]['joinDate'];
            $lastStudentDays = Carbon::parse($lastDateOfMonth)->diffInDays(Carbon::parse($lastStudentJoinDate));
            $bill = $lastStudentDays * $perDayUnit;
            $bill = round(($bill / ($noOfNewStudents + $noOfOldStudens)), 2);
            if (!empty($newStudentBill)) {
                for ($j = 0; $j < count($newStudentBill); $j++) {
                    $newStudentBill[$j] += $bill;
                }
            }
            array_push($newStudentBill, $bill);
        }
        // old students

        if ($noOfOldStudens !== 0) {
            $diffBetweenDaysOfFirstNewStudent = Carbon::parse($currentMonthStartDate)->diffInDays(Carbon::parse($NewStudents[0]['joinDate'])) + 1;
            $totalUnitOfNewStudents = array_sum($newStudentBill);
            for ($old = 0; $old < $noOfOldStudens; $old++) {
                $bill = (($units - $totalUnitOfNewStudents) / $noOfOldStudens);
                $oldStudentBills[$old] = round($bill, 2);
            }
        }

        for ($preNew = 0; $preNew < $noOfNewStudents; $preNew++) {
            $NewStudents[$preNew]['TotalUnit'] = $newStudentBill[$preNew];
            $NewStudents[$preNew]['TotalAmount'] = $newStudentBill[$preNew] * $prUnitRate;
        }
        for ($preOld = 0; $preOld < $noOfOldStudens; $preOld++) {
            $oldStudents[$preOld]['TotalUnit'] = $oldStudentBills[$preOld];
            $oldStudents[$preOld]['TotalAmount'] = $oldStudentBills[$preOld] * $prUnitRate;
        }
        $finalRecords = array_merge($NewStudents, $oldStudents);
        return $finalRecords;
    }
    public function view(Request $request)
    {
        $presentReadingDateFormated = "";
        $previousReadingDateFormated = "";
        $currentMonth = Carbon::now()->format('m');
        $currentYear = Carbon::now()->format('Y');
        $selectedMonth = $request->input('selected_month', $currentMonth);

        $PersentReadingDate = DB::table('electicity_management')
            ->where(DB::raw('MONTH(BillDate)'), '=', $selectedMonth)
            ->where(DB::raw('YEAR(BillDate)'), '=', $currentYear)
            ->first();

        $previousReadingDate = DB::table('electicity_management')
            ->where(DB::raw('MONTH(BillDate)'), '=', $selectedMonth - 1)
            ->where(DB::raw('YEAR(BillDate)'), '=', $currentYear)
            ->first();
        if ($PersentReadingDate) {
            $presentReadingDateFormated = Carbon::parse($PersentReadingDate->BillDate)->format('d-M-Y');
        }
        if ($previousReadingDate) {
            $previousReadingDateFormated = Carbon::parse($previousReadingDate->BillDate)->format('d-M-Y');
        }
        // try {
        $ElectricityBillData = ElectricityManagement::where(DB::raw('MONTH(BillDate)'), '=', $selectedMonth)
            ->where(DB::raw('YEAR(BillDate)'), '=', $currentYear)
            ->get();
        $billData = [];
        if ($ElectricityBillData) {
            foreach ($ElectricityBillData as $bill) {
                $newStudentRecords = $this->CheckNewStudents($bill->roomno, $selectedMonth);
                $oldStudentRecords = $this->CheckOldStudents($bill->roomno, $selectedMonth);
                $leftStudentsRecords = $this->CheckLeftStudents($bill->roomno, $selectedMonth);
                $NoOfNewStudents = count($newStudentRecords);
                $NoOfOldStudents = count($oldStudentRecords);
                $NoOfLeftStudents = count($leftStudentsRecords);

                if ($NoOfNewStudents === 0 && $NoOfOldStudents > 0 && $NoOfLeftStudents === 0) {
                    $studentRecord = $this->CalculateBillForOldStudents($oldStudentRecords, $bill->units, $bill->readingRate);
                    $billData[$bill->roomno] = $studentRecord;
                } else if ($NoOfNewStudents > $NoOfOldStudents && $NoOfOldStudents === 0 && $NoOfLeftStudents === 0) {
                    $data = $this->CalculateBillForNewStudents($newStudentRecords, $bill->units, $bill->readingRate);
                    $billData[$bill->roomno] = $data;
                } else if ($NoOfLeftStudents > 0) {
                    $leftStudentData = $this->CaluculateBillForLeftStudents($bill->roomno, $bill->units, $bill->readingRate, $selectedMonth);
                    $billData[$bill->roomno] = $leftStudentData;
                    // dd($leftStudentData);
                } else {
                    if (!empty($newStudentRecords) && !empty($oldStudentRecords)) {
                        $mixStudentBill = $this->calculateBillForNewAndOldStudents($bill->roomno, $bill->units, $bill->readingRate, $selectedMonth);
                        $billData[$bill->roomno] = $mixStudentBill;
                    }
                }
                $billData[$bill->roomno]['previousReading'] = $bill->previous_reading;
                $billData[$bill->roomno]['presentReading'] = $bill->present_reading;
                $billData[$bill->roomno]['BillId'] = $bill->id;
            }
        }
        dd($billData);
        return view('fronted.billViewclone', compact('billData', 'selectedMonth', 'presentReadingDateFormated', 'previousReadingDateFormated'));
        // } catch (\Exception $e) {
        //     dd($e->getMessage());
        //     dd($billData);
        //     return view('fronted.billViewclone', compact('billData', 'selectedMonth', 'presentReadingDateFormated', 'previousReadingDateFormated'));
        // }
    }

    public function StudentElectiricityBillView(Request $request)
    {
        $PrenseBillDate = "";
        $PreviousBillDate = "";
        $currentMonth = Carbon::now()->format('m');
        $currentYear = Carbon::now()->format('Y');
        $selectedMonth = $request->input('selected_month', $currentMonth);
        $PersentReadingDate = DB::table('electicity_management')
            ->where(DB::raw('MONTH(BillDate)'), '=', $selectedMonth)
            ->where(DB::raw('YEAR(BillDate)'), '=', $currentYear)
            ->first();

        $previousReadingDate = DB::table('electicity_management')
            ->where(DB::raw('MONTH(BillDate)'), '=', $selectedMonth - 1)
            ->where(DB::raw('YEAR(BillDate)'), '=', $currentYear)
            ->first();
        if ($PersentReadingDate) {
            $PrenseBillDate = Carbon::parse($PersentReadingDate->BillDate)->format('d-M-Y');
        }
        if ($previousReadingDate) {
            $PreviousBillDate = Carbon::parse($previousReadingDate->BillDate)->format('d-M-Y');
        }
        $ElecticitybillResult = DB::table('electicity_management')
            ->join('students_electricity_bill', 'electicity_management.roomno', '=', 'students_electricity_bill.roomno')
            ->join('studentregisters', 'students_electricity_bill.userId', '=', 'studentregisters.formno')
            ->where(DB::raw('MONTH(students_electricity_bill.billDate)'), '=', $selectedMonth)
            ->where(DB::raw('YEAR(students_electricity_bill.billDate)'), '=', $currentYear)
            ->where(DB::raw('MONTH(electicity_management.BillDate)'), '=', $selectedMonth)
            ->where(DB::raw('YEAR(electicity_management.BillDate)'), '=', $currentYear)
            ->where('studentregisters.status', 1)
            ->select(
                'electicity_management.previous_reading',
                'electicity_management.present_reading',
                'electicity_management.units',
                'students_electricity_bill.*', // Select all columns from students_electricity_bill
                'studentregisters.candidatename'
            )

            ->orderBy("electicity_management.roomno", "asc")
            ->orderBy("students_electricity_bill.seatNo", 'desc')
            ->get();
        return view('fronted.studentElecticityBill', compact('ElecticitybillResult', 'selectedMonth', 'PrenseBillDate', 'PreviousBillDate'));
    }
}
