<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Models\Expense;
use App\Models\StockItem;
use App\Models\stock_detail;
use App\Models\Expensedetail;
use App\Models\StockCategory;
use Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;

class ExpensesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    function DeleteStockITems(Request $request)
    {
        try {
            $data = $request['itemDetails'];
            $data = explode(",", $data);
            $updateData = stock_detail::where("item_id", $data[0])
                ->where("category_id", $data[1])
                ->where("month", $data[2])
                ->first();
            if ($updateData) {
                $updateData->delete();
                return response()->json("success");
            } else {
                return response()->json("error", 500);
            }
        } catch (Exception $e) {
            return response()->json("error", "Somthing Wrong");
        }
    }
    function AddUsedStockData(Request $request)
    {
        try {
            $data = $request['EstData'];
            $estimationValues = $data['estimationValues'];
            $itemCategoryIds = $data['itemCategoryIds'];
            $lenth = sizeof($itemCategoryIds);
            for ($i = 0; $i < $lenth; $i++) {
                $ItemIDArry = explode(",", $itemCategoryIds[$i]);
                $item = $estimationValues[$i];
                $UsedStockAdd = stock_detail::where("item_id", $ItemIDArry[0])
                    ->where("category_id", $ItemIDArry[1])
                    ->where("month", $ItemIDArry[2])
                    ->first();
                if ($UsedStockAdd) {
                    $UsedStockAdd->used_stock = $item;
                    $UsedStockAdd->save();
                } else {
                    return response()->json("error", 500);
                }
            }
        } catch (Exception $e) {
            return response()->json("error", 500);
        }
    }
    function AddStockCetegory(Request $request)
    {
        $categoryName = $request["NewCategory"];
        $data = new StockCategory;
        $data->category_name = $categoryName;
        if ($data->save()) {
            return response()->json(["category_name" => $categoryName, "id" => $data->id]);
        } else {
            return response()->json("error", 500);
        }
    }
    public function StoreEstimationOrder(Request $request)
    {
        // try {
        $estOrderdata = $request['EstOrdeData'];
        $tableOrder = $estOrderdata['tableOrder'];
        $itemCategoryIdsMonth = $estOrderdata['itemCategoryIds'];
        $estOrderValue = $estOrderdata['estimationValues'];
        $lenth = sizeof($itemCategoryIdsMonth);
        $date = Carbon::now();
        $formattedDate = $date->format('Y-m-d');
        for ($i = 0; $i < $lenth; $i++) {
            $ItemIDArry = explode(",", $itemCategoryIdsMonth[$i]);
            $item = $estOrderValue[$i];
            $orderSave = stock_detail::where("item_id", $ItemIDArry[0])
                ->where("category_id", $ItemIDArry[1])
                ->where("month", $ItemIDArry[2])
                ->first();
            if ($orderSave) {
                $existingOrderDates = $orderSave->orderDate;
                if ($tableOrder == 1) {
                    $orderSave->order1 = $item;
                } elseif ($tableOrder == 2) {
                    $orderSave->order2 = $item;
                } elseif ($tableOrder == 3) {
                    $orderSave->order3 = $item;
                } else {
                    break;
                    return response()->json(["error" => "This month All Order Done"], 500);
                }
                if ($tableOrder == 1) {
                    if (empty($existingOrderDates)) {
                        $updatedOrderDates = [$formattedDate];
                    } else {
                        $explodeOrderDates = explode(",", $existingOrderDates);
                        $explodeOrderDates[0] = $formattedDate;
                        $updatedOrderDates = $explodeOrderDates;
                    }
                } elseif ($tableOrder >= 2 && $tableOrder <= 3) {
                    $updatedOrderDates = explode(",", $existingOrderDates);
                    $updatedOrderDates[$tableOrder - 1] = $formattedDate;
                }
                $updatedOrderDate = implode(",", $updatedOrderDates);
                // Update the orderDate column with the new value
                $orderSave->orderDate = $updatedOrderDate;
                if ($orderSave->save()) {
                    $response = true;
                } else {
                    $response = false;
                    break;
                }
            } else {
                $response = false;
            }
        }
        if ($response == true) {
            return response()->json("success", 200);
        } else {
            // throw  new Exception("Data not saved");
        }
        // } catch (Exception $e) {
        //     return response()->json($e, 500);
        // }
    }
    public function StoreEstimationStock(Request $request)
    {
        try {
            $estData = $request['EstData'];
            $month = $estData['month'];
            $itemCategoryIds = $estData['itemCategoryIds'];
            $StockEstItemValue = $estData['estimationValues'];
            $lenth = sizeof($itemCategoryIds);
            $date =   Carbon::now();
            for ($i = 0; $i < $lenth; $i++) {
                $ItemIDArry =  explode(",", $itemCategoryIds[$i]);
                $item =   $StockEstItemValue[$i];
                $checkDetails = stock_detail::where("item_id", $ItemIDArry[0])
                    ->where("category_id", $ItemIDArry[1])
                    ->where("month", $month)
                    ->first();
                if ($checkDetails) {
                    $checkDetails->item_id = $ItemIDArry[0];
                    $checkDetails->category_id = $ItemIDArry[1];
                    $checkDetails->month = $month;
                    $checkDetails->est_stock = $item;
                    $checkDetails->Date = $date;
                    $checkDetails->update();
                } else {
                    $storeEst = new stock_detail;
                    $storeEst->item_id = $ItemIDArry[0];
                    $storeEst->category_id = $ItemIDArry[1];
                    $storeEst->month = $month;
                    $storeEst->est_stock = $item;
                    $storeEst->Date = $date;
                    $storeEst->save();
                }
            }
            return response()->json("Success", 200);
        } catch (Exception $e) {
            return response()->json("error", 500);
        }
    }
    public function StoreStockItems(Request $request)
    {
        $tableData = $request['TableData'];
        $categoryName = $request['categoryName'];
        if ($categoryName != "") {
            $data = new StockCategory;
            $data->category_name = $categoryName;
            $data->save();
            $categoryID = $data->id;
        }
        foreach ($tableData as $data) {
            $string = $data['category'];
            if (preg_match('/\((\d+)\)/', $string, $matches)) {
                $intValue = intval($matches[1]);
            } else {
                $intValue =  $categoryID;
            }
            $StockItem = new StockItem;
            $StockItem->category_id = $intValue;
            $StockItem->itemName = $data['name'];
            $StockItem->itemUnite = $data['units'];
            $StockItem->save();
        }
        return response()->json("DataSubmit");
    }
    public function getGetegoryNames()
    {
        $expenseCategory = StockCategory::select("id", "category_name")->get();
        if ($expenseCategory) {
            return response()->json($expenseCategory);
        } else {
            return response()->json("erro", 500);
        }
    }
    public function getExpenseTotals(Request $request)
    {
        // Retrieve the expense totals from the database
        $filterKeyword = $request['type'];

        if ($filterKeyword == 'year') {
            $year = Carbon::now()->year;
            $expenseTotals = DB::table('expensedetails')
                ->join('expenses', 'expensedetails.category_id', '=', 'expenses.id')
                ->select('expenses.category_name as category', DB::raw('SUM(expensedetails.amount) as amount'))
                ->whereYear('expensedetails.billdate', $year) // Add the whereYear condition
                ->groupBy('expenses.category_name')
                ->get();
            return response()->json($expenseTotals);
        } elseif ($filterKeyword == 'quarter') {
            $year = Carbon::now()->year;
            $expenseTotals = DB::table('expensedetails')
                ->join('expenses', 'expensedetails.category_id', '=', 'expenses.id')
                ->select('expenses.category_name as category', DB::raw('SUM(expensedetails.amount) as amount'))
                ->whereYear('expensedetails.billdate', $year) // Add the whereYear condition
                ->groupBy('expenses.category_name', DB::raw('QUARTER(expensedetails.billdate)'))
                ->orderBy(DB::raw('QUARTER(expensedetails.billdate)'))
                ->get();
            return response()->json($expenseTotals);
        } else if ($filterKeyword == 'month') {
            $currentMonth = date('m');
            $currentDay = date('d');
            $currentYear = date('Y');
            $expenseTotals = DB::table('expensedetails')
                ->join('expenses', 'expensedetails.category_id', '=', 'expenses.id')
                ->select('expenses.category_name as category', DB::raw('SUM(expensedetails.amount) as amount'))
                ->whereMonth('expensedetails.billdate', '=', $currentMonth)
                ->whereDay('expensedetails.billdate', '<=', $currentDay)
                ->whereYear('expensedetails.billdate',"=",$currentYear)
                ->groupBy('expenses.category_name', DB::raw('MONTH(expensedetails.billdate)'))
                ->orderBy(DB::raw('MONTH(expensedetails.billdate)'))
                ->get();
            return response()->json($expenseTotals);
        } else if ($filterKeyword == 'custom') {
            $startDate = $request->input('startDate');
            $endDate = $request->input('endDate');
            $expenseTotals = DB::table('expensedetails')
                ->join('expenses', 'expensedetails.category_id', '=', 'expenses.id')
                ->select('expenses.category_name as category', DB::raw('SUM(expensedetails.amount) as amount'))
                ->whereBetween('expensedetails.billdate', [$startDate, $endDate])
                ->groupBy('expenses.category_name')
                ->get();
            return response()->json($expenseTotals);
        } else if ($filterKeyword == 'Months') {
            $currentYear = date('Y');
            $currentMonth = date('m');
            if ($currentMonth < 4) {
                $startDate = ($currentYear - 1) . "-04-01";
                $endDate = $currentYear . "-03-31";
            } else {
                $startDate = $currentYear . "-04-01";
                $endDate = ($currentYear + 1) . "-03-31";
            }
            $expenseTotals = DB::table('expensedetails')
                ->join('expenses', 'expensedetails.category_id', '=', 'expenses.id')
                ->select('expenses.category_name as category', DB::raw('SUM(expensedetails.amount) as amount'))
                ->whereBetween('expensedetails.billdate', [$startDate, $endDate])
                ->groupBy('expenses.category_name')
                ->get();
            return response()->json($expenseTotals);
        } else {
            $expenseTotals = DB::table('expensedetails')->join('expenses', 'expensedetails.category_id', '=', 'expenses.id')
                ->select('expenses.category_name as category', DB::raw('SUM(expensedetails.amount) as amount'))
                ->groupBy('expenses.category_name')
                ->get();
            // Return the expense totals as JSON response
            return response()->json($expenseTotals);
        }
    }
    public function index()
    {
        return redirect('expenses', compact('expenses'));
    }

    public function getExpensesGraphData()
    {
        try {
            $currentYear = date('Y');
            $currentMonth = date('m');
            if ($currentMonth < 4) {
                $startDate = ($currentYear - 1) . "-04-01";
                $endDate = $currentYear . "-03-31";
            } else {
                $startDate = $currentYear . "-04-01";
                $endDate = ($currentYear + 1) . "-03-31";
            }
            $ExpensesmonthlyExp = DB::table('expensedetails')
                ->select(DB::raw('YEAR(billdate) AS year_num'), DB::raw('MONTH(billdate) AS month_num'), DB::raw('SUM(amount) AS expenses_amount'))
                ->whereBetween('billdate', [$startDate, $endDate])
                ->groupBy(DB::raw('YEAR(billdate)'), DB::raw('MONTH(billdate)'))
                ->orderBy(DB::raw('YEAR(billdate)'), 'ASC')
                ->get();
            $labels = [];
            $expensetotalAmount = [];
            $expensetotalAmount = array_fill(1, 12, 0);
            foreach ($ExpensesmonthlyExp as $expense) {
                $monthNum = intval($expense->month_num);
                $expensetotalAmount[$monthNum] = round($expense->expenses_amount);
            }
            for ($monthNum = 1; $monthNum <= 12; $monthNum++) {
                $monthLabels[] = date("M", mktime(0, 0, 0, $monthNum, 1));
            }
            $response = [
                'labels' => $monthLabels,
                'totalAmount' => array_values($expensetotalAmount)
            ];
            return response()->json($response);
        } catch (Exception $e) {
            return response()->json($e->getMessage());
        }
    }

    public function expensesfilter(Request $request)
    {
        $startDate = $request->input('startDate');
        $endDate = $request->input('endDate');
        $totalExpense = DB::table('expenses')
            ->join('expensedetails', 'expenses.id', '=', 'expensedetails.category_id')
            ->whereBetween('expensedetails.billdate', [$startDate, $endDate])
            ->select(DB::raw('SUM(expensedetails.amount) as total'))
            ->value('total');
        if ($totalExpense == null) {
            $totalExpense = 0;
        }
        $dataexpensess = DB::table('expenses')
            ->leftJoin('expensedetails', 'expenses.id', '=', 'expensedetails.category_id')
            ->select('expenses.category_name', 'expenses.id', DB::raw('COALESCE(SUM(expensedetails.amount), 0) as total'))
            ->whereBetween('expensedetails.billdate', [$startDate, $endDate])
            ->groupBy('expenses.id', 'expenses.category_name')
            ->orderBy("expenses.category_name", "ASC")
            ->get();
        if ($dataexpensess) {
            return view('fronted.expenses', compact('dataexpensess', 'totalExpense'));
        } else {
            return redirect(url('/'))->with('error', 'sorry this field is not update');
        }
        //return view('fronted.expenses', compact('dataexpensess'));
    }
    public function expenses_view()
    {
        $totalExpense = DB::table('expenses')
            ->join('expensedetails', 'expenses.id', '=', 'expensedetails.category_id')
            ->select(DB::raw('SUM(expensedetails.amount) as total'))
            ->value('total');
        if ($totalExpense == '') {
            $totalExpense = 0;
        }
        $dataexpensess = DB::table('expenses')
            ->leftJoin('expensedetails', 'expenses.id', '=', 'expensedetails.category_id')
            ->select('expenses.category_name', 'expenses.id', DB::raw('COALESCE(SUM(expensedetails.amount),
        0) as total'))
            ->groupBy('expenses.id', 'expenses.category_name')
            ->orderBy("expenses.category_name", "ASC")
            ->get();
        if ($dataexpensess) {
            return view('fronted.expenses', compact('dataexpensess', 'totalExpense'));
        } else {
            return redirect(url('/'))->with('error', 'sorry this field is not update');
        }
    }
    public function category($id)
    {
        $expensesadd = DB::table('expenses')->where('id', $id)->first();
        $totalAmount = DB::table('expensedetails')->where('category_id', $expensesadd->id)->get()->sum('amount');
        $expense = DB::table('expensedetails')
            ->where('category_id', $expensesadd->id)
            ->orderBy("billdate", "desc")
            ->get();

        $categorys = DB::table('expenses')
            ->orderBy("category_name", "ASC")
            ->get();
        if ($expensesadd) {
            return view('fronted.add_expense', compact('expensesadd', 'totalAmount', 'expense', 'categorys'));
        } else {
            return redirect(url('/'))->with('error', 'sorry this field is not update');
        }
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
    }
    public function store(Request $request)
    {
        $data = new Expense;
        $data->category_name = $request->category_name;
        $data->save();
        return redirect('expenses')->with('success', ' Category Added Successfully');
    }
    public function edit($id)
    {
        $dataaddexpense =  Expensedetail::find($id);
        return response()->json([
            'status' => 200,
            'addexpense' => $dataaddexpense,
        ]);
    }
    public function editexpenses($id)
    {
        $dataexpense =  Expense::find($id);
        return response()->json([
            'status' => 200,
            'expense' => $dataexpense,
        ]);
    }
    public function datefilter(Request $request, $id)
    {
        $startDate = $request->startDate;
        $endDate = $request->endDate;
        $expense = Expensedetail::where('category_id', $id)
            ->whereBetween('billdate', [$startDate, $endDate])
            ->orderBy('billdate', 'asc')
            ->get();
        $expensesadd = DB::table('expenses')->where('id', $id)->first();
        $totalAmount = Expensedetail::where('category_id', $id)
            ->whereBetween('billdate', [$startDate, $endDate])
            ->sum('amount');
        $categorys = DB::table('expenses')->get();
        return view('fronted.add_expense', compact('expense', 'expensesadd', 'totalAmount', 'categorys'));
    }
    public function update(Request $request)
    {
        $addexpenses_id = $request->input('addexpenses_id');
        // return $request->input();
        $data = Expensedetail::find($addexpenses_id);
        if ($data) {
            // $data->category_id = $request->category_id;
            $data->billdate = $request->billdate;
            $data->itemname = $request->itemname;
            $data->quantity = $request->quantity;
            $data->rate = $request->rate;
            $data->amount = $request->amount;
            $data->paymentmode = $request->paymentmode;
            if ($request->hasfile('uploadbill')) {
                $file = $request->file('uploadbill');
                $extention =  $file->getClientOriginalExtension();
                $filename = time() . '.' . rand() . '.' . $extention;
                $file->move('assets/uploads/', $filename);
                $data->uploadbill = $filename;
            }
            $data->update();
            return back()->with('warning', 'Item Update successful!');
        } else {
            return back()->with('error', 'Data not found.');
        }
    }
    public function updateexpenses(Request $request)
    {
        $expenses_id = $request->input('expenses_id');
        $data = Expense::find($expenses_id);
        //return $request->input(); 
        if ($data) {
            $data->category_name = $request->category_name;
            $data->update();
            return back()->with('warning', ' Category Update successful!');
        } else {
            return back()->with('error', 'data not Update here');
        }
    }
    public function destroy($id)
    {
        $data = Expense::find($id);
        $data->delete();
        return redirect('expenses')->with('danger', 'Category Delete Successfully');
    }
    public function store1(Request $request)
    {
        $request->validate(
            [
                'billdate' => 'required',
                'itemname' => 'required',
                'quantity' => 'required',
                'rate'  => 'required',
                'amount'     => 'required',
                'paymentmode'   => 'required',
            ],
            [
                'quantity' => 'Please input Quantity',
                'amount' => 'Please input amount',
            ]
        );
        $data = new Expensedetail;
        $data->billdate = $request->billdate;
        $data->itemname = $request->itemname;
        $data->category_id = $request->category_id;
        $data->quantity = $request->quantity;
        $data->rate = $request->rate;
        $data->amount = $request->amount;
        $data->paymentmode = $request->paymentmode;
        if ($request->hasfile('uploadbill')) {
            $file = $request->file('uploadbill');
            $extention =  $file->getClientOriginalExtension();
            $filename = time() . '.' . rand() . '.' . $extention;
            $file->move('assets/uploads/', $filename);
            $data->uploadbill = $filename;
        }
        $data->save();
        return back()->with('success', 'Expenses Add Successfully');
    }
    public function destroy1($id)
    {
        $data = Expensedetail::find($id);
        $data->delete();
        return back()->with('danger', 'Expenses Delete Successfully');
    }
    public function graphfilterExpenses(Request $request)
    {
        $startDate = $request['startDate'];
        $endDate = $request['endDate'];
        $monthlyExp = DB::table('expensedetails')
            ->select(DB::raw('DATE_FORMAT(billdate, "%m") AS month_num'), DB::raw('SUM(amount) AS total_amount'))
            ->whereBetween('billdate', [$startDate, $endDate])
            ->groupBy(DB::raw('DATE_FORMAT(billdate, "%m")'))
            ->orderBy(DB::raw('DATE_FORMAT(billdate, "%m")'))
            ->get();
        // Prepare the response data
        $monthLabels = [];
        $totalAmount = [];
        foreach ($monthlyExp as $expense) {
            $monthNum = intval($expense->month_num);
            $monthName = date("F", mktime(0, 0, 0, $monthNum, 1));
            $monthLabels[] = $monthName;
            $totalAmount[] = $expense->total_amount;
        }
        // Create the response array
        $response = [
            'labels' => $monthLabels,
            'totalAmount' => $totalAmount
        ];
        // Return the response as JSON
        return response()->json($response);
    }
    public function expensesgraph(Request $request)
    {
        $filterKeyword = $request['type'];
        $labels = [];
        $totalAmount = [];
        // Initialize the query builder
        $query = DB::table('expensedetails')
            ->select(DB::raw('YEAR(billdate) AS year_num'), DB::raw('MONTH(billdate) AS month_num'), DB::raw('SUM(amount) AS total_amount'))
            ->groupBy(DB::raw('YEAR(billdate)'), DB::raw('MONTH(billdate)'))
            ->orderBy(DB::raw('YEAR(billdate)'), 'asc');
        $result = $query->get();
        if ($filterKeyword == 'year') {
            $query = DB::table('expensedetails')
                ->select(DB::raw('YEAR(billdate) AS year_num'), DB::raw('SUM(amount) AS total_amount'))
                ->groupBy(DB::raw('YEAR(billdate)'))
                ->orderBy(DB::raw('YEAR(billdate)'));
            $year_exp = $query->get();
            foreach ($year_exp as $row) {
                $yearNum = $row->year_num;
                $yearTotal[$yearNum] = round($row->total_amount);
                $labels[] = $yearNum;
            }
            $response = [
                'labels' => $labels,
                'totalAmount' => array_values($yearTotal),
            ];
        } elseif ($filterKeyword == 'quarter') {
            $currentYear = date('Y');
            $currentMonth = date('m');
            if ($currentMonth < 4) {
                $startDate = ($currentYear - 1) . "-04-01";
                $endDate = $currentYear . "-03-31";
            } else {
                $startDate = $currentYear . "-04-01";
                $endDate = ($currentYear + 1) . "-03-31";
            }              // Retrieve the quarterly sales data
            $expensesData = DB::table('expensedetails')
                ->select(DB::raw('QUARTER(billdate) AS quarter_num'), DB::raw('SUM(amount) AS expenses_amount'))
                ->whereBetween('billdate', [$startDate, $endDate])
                ->groupBy(DB::raw('QUARTER(billdate)'))
                ->orderBy(DB::raw('QUARTER(billdate)'))
                ->get();
            // Create an array to store the quarterly totals
            $quarterTotals = array_fill(1, 4, 0); // Initialize all quarters with zero totals
            // Populate the array with the retrieved quarterly totals
            foreach ($expensesData as $row) {
                $quarterNum = $row->quarter_num;
                $quarterTotals[$quarterNum] = round($row->expenses_amount);
            }
            // Generate the labels for the quarters
            $labels = ['Q1', 'Q2', 'Q3', 'Q4'];
            // Prepare the data for the response
            $response = [
                'labels' => $labels,
                'totalAmount' => array_values($quarterTotals),
            ];
            return response()->json($response);
        } else if ($filterKeyword == 'month') {
            $currentMonth = date('m');
            $currentDay = date('d');
            $currentYear = date('Y');
            $query = DB::table('expensedetails')
                ->select(DB::raw('DATE_FORMAT(billdate, "%d") AS days'), DB::raw('amount AS total_amount'))
                ->whereMonth('billdate', '=', $currentMonth)
                ->whereDay('billdate', '<=', $currentDay)
                ->whereYear('billdate',"=", $currentYear);
            $monthlyExp = $query->get();
            $totalDays = Carbon::now()->daysInMonth;
            for ($day = 1; $day <= $totalDays; $day++) {
                $labels[] = date("d", mktime(0, 0, 0, $currentMonth, $day));
                $totalAmount[$day] = 0;
            }
            foreach ($monthlyExp as $expense) {
                $monthNum = intval($expense->days);
                $totalAmount[$monthNum] += round($expense->total_amount);
            }
            $totalAmount = array_values($totalAmount);
            $response = [
                'labels' => $labels,
                'totalAmount' => $totalAmount
            ];
        } elseif ($filterKeyword == 'Months') {
            $currentYear = date('Y');
            $currentMonth = date('m');
            if ($currentMonth < 4) {
                $startDate = ($currentYear - 1) . "-04-01";
                $endDate = $currentYear . "-03-31";
            } else {
                $startDate = $currentYear . "-04-01";
                $endDate = ($currentYear + 1) . "-03-31";
            }
            $ExpensesmonthlyExp = DB::table('expensedetails')
                ->select(DB::raw('YEAR(billdate) AS year_num'), DB::raw('MONTH(billdate) AS month_num'), DB::raw('SUM(amount) AS expenses_amount'))
                ->whereBetween('billdate', [$startDate, $endDate])
                ->groupBy(DB::raw('YEAR(billdate)'), DB::raw('MONTH(billdate)'))
                ->orderBy(DB::raw('YEAR(billdate)'), 'ASC')
                ->get();
            $labels = [];
            $expensetotalAmount = [];
            $expensetotalAmount = array_fill(1, 12, 0);
            foreach ($ExpensesmonthlyExp as $expense) {
                $monthNum = intval($expense->month_num);
                $expensetotalAmount[$monthNum] = round($expense->expenses_amount);
            }
            for ($monthNum = 1; $monthNum <= 12; $monthNum++) {
                $monthLabels[] = date("M", mktime(0, 0, 0, $monthNum, 1));
            }
            $response = [
                'labels' => $monthLabels,
                'totalAmount' => array_values($expensetotalAmount)
            ];
        } elseif ($filterKeyword == 'custom') {
            $startDate = $request['startDate'];
            $endDate = $request['endDate'];
            $ExpensesmonthlyExp = DB::table('expensedetails')
                ->select(DB::raw('YEAR(billdate) AS year_num'), DB::raw('MONTH(billdate) AS month_num'), DB::raw('SUM(amount) AS expenses_amount'))
                ->whereBetween('billdate', [$startDate, $endDate])
                ->groupBy(DB::raw('YEAR(billdate)'), DB::raw('MONTH(billdate)'))
                ->orderBy(DB::raw('YEAR(billdate)'), 'ASC')
                ->get();
            $monthLabels = [];
            $expensetotalAmount = array_fill(1, 12, 0); // Initialize only if needed

            foreach ($ExpensesmonthlyExp as $expense) {
                $monthNum = intval($expense->month_num);
                $expensetotalAmount[$monthNum] = round($expense->expenses_amount);
            }

            // Generate the month labels and total amounts
            for ($monthNum = 1; $monthNum <= 12; $monthNum++) {
                $monthLabels[] = date("M", mktime(0, 0, 0, $monthNum, 1));
            }
            $response = [
                'labels' => $monthLabels,
                'totalAmount' => array_values($expensetotalAmount)
            ];
        } else {
            $query = DB::table('expensedetails')
                ->select(DB::raw('YEAR(billdate) AS year_num'), DB::raw('MONTH(billdate) AS month_num'), DB::raw('SUM(amount) AS total_amount'))
                ->groupBy(DB::raw('YEAR(billdate)'), DB::raw('MONTH(billdate)'))
                ->orderBy(DB::raw('YEAR(billdate)'), 'asc');
            $result = $query->get();
            for ($monthNum = 1; $monthNum <= 12; $monthNum++) {
                $labels[] = date("M", mktime(0, 0, 0, $monthNum, 1));
                $totalAmount[$monthNum] = 0;
            }
            // Sum up the total amounts for each month
            foreach ($result as $expense) {
                $monthNum = intval($expense->month_num);
                $totalAmount[$monthNum] += $expense->total_amount;
            }
            $totalAmount = array_values($totalAmount);
            $response = [
                'labels' => $labels,
                'totalAmount' => $totalAmount
            ];
        };
        return response()->json($response);
    }
    public function Categoryname($id)
    {
        $data = Expense::find($id);
        if ($data) {
            $categoryName = $data->category_name;
            // Use the $categoryName variable as needed
        } else {
            // Handle the case where the record with the specified ID is not found
            $categoryName = '';
        }
        return $categoryName;
    }
}
