<?php 
namespace App\Http\Controllers;

use Carbon\Carbon as CarbonCarbon;
use Illuminate\Support\Facades\Config;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use DB;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\Mail;
use App\Http\Modal;
use App\Models\Businessregister;
use Exception;
use Illuminate\Support\Facades\Hash;


class ForgotPasswordManager extends Controller 
{
    function forgetPasswordPost(Request $request){
        config(['database.default' => env('DB_CONNECTION')]);
        $request->validate([
            'email'=>'required|email|exists:businessregisters'
        ]);

        $token = Str::random(65);
        DB::table("password_resets")->insert([
            'email'=>$request->email,
            'token'=>$token,
            'created_at'=>Carbon::now()
        ]);
        Mail::send('emails.forget-password',['token'=>$token], function($message) use ($request){
            $message->to($request->email);
            $message->subject("Reset Password");
        });

        return back()->with('PasswordSend',"Your Password Reset link send to your Email address successfully.");
    }
    function resetPassword($token){
        return view('forget-password',compact("token"));
    }

    function resetPasswordPost(Request $request){
        config(['database.default' => env('DB_CONNECTION')]);
        $request->validate([
            'email'=>'required|email|exists:businessregisters',
            'password'=>'required|string|min:8|confirmed',
            'password_confirmation'=>"required"
        ]);

        $updatePasword = DB::table("password_resets")->where([
            'email'=>$request->email,
            'token'=>$request->token
        ])->first();

        if(! $updatePasword){
            return back()->with("error","Your Your Password Reset link has been expired. Try Again...");
        }

        try{
            Businessregister::where("email",$request->email)->update(["password" => Hash::make($request->password)]);
            $updatePasword = DB::table("password_resets")->where("email",$request->email)->delete();
        }
        catch(Exception $e){
            return back()->with("error","Somthing Wrong");
        }
        return redirect()->to(route("login"))->with("PasswordSend","Your Password is updated successfully.");
    }
}
