<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Route;
use Illuminate\Http\Request;
use DB;
use App\Models\Gallery;
use App\Models\Termsandcondition;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Storage;

class GalleryController extends Controller
{
    public function store(Request $request)
    {
    $data = new Gallery();
        $data->gallerydate = $request->gallerydate;
        $data->gallerytype = $request->gallerytype;
        $data->roomnogallery = $request->roomnogallery;
       
        if ($request->hasFile('imageupload')) {
            $imageArray = [];
    
            foreach ($request->file('imageupload') as $file) {
                $extension = $file->getClientOriginalExtension();
                $filename = time() . '.' . rand() . '.' . $extension;
                $file->move('assets/uploads/', $filename);
                $imageArray[] = $filename;
            }
    
            $data->imageupload = implode(',', $imageArray);
        }
        //dd($data);
        $data->save();

        return back()->with('image', 'Image uploaded successfully'); 
}
  
    public function destroy($id)
    {
        $data = Gallery::find($id);
        $data->delete();
        return redirect('galleryupload')->with('danger', 'Category Delete Successfully');

    }
    public function deleteSelected(Request $request)
    {
        $selectedImageIds = $request->input('imageupload');

        // Check if selectedImageIds is null or not an array
        if (!is_array($selectedImageIds) || empty($selectedImageIds)) {
            return redirect()->back()->with('error', 'No images selected for deletion. Please try again.');
        }

        foreach ($selectedImageIds as $selectedImageId) {
            $gallery = Gallery::find($selectedImageId);

            if ($gallery) {
                // Delete the image file using your preferred method
                // For example, if you are using the public storage disk:
                Storage::delete('assets/uploads/' . $gallery->imageupload);

                // Remove the image path from the database
                $gallery->imageupload = null;
                $gallery->save();
            }
        }

        return redirect()->back()->with('success', 'Selected images deleted successfully.');
    }
    
    public function termsandconditions(Request $request)
    {
        $recordCount = Termsandcondition::count();
        
        if ($recordCount >= 5) {
            return back()->with('termsconditions', 'Only 5 records are allowed');
        }
        
        $data = new Termsandcondition();
        $data->termsandconditions = $request->termsandconditions;
        $data->save();
    
        return back()->with('termssuccess', 'Record saved successfully');
    }
    
    
    public function termsandconditionsdelete($id)
    {
        $data = Termsandcondition::find($id);
        $data->delete();
        return redirect('galleryupload')->with('terms', 'Category Delete Successfully');

    }
}
