<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Feature;
use App\Models\Subscription;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Str;
use Config;
use App\Models\Salesubscription;
use Illuminate\Support\Carbon;


class SubscriptionModal extends Controller
{
  public function PakageDetails()
  {
    config(['database.default' => "custom"]);
    $package_title = DB::table('subscriptions')
      ->where('status', 1)
      ->whereNotIn('package_duration', ['7 Days', '15 Days'])
      ->select('package_title', 'package_duration')
      ->distinct()
      ->get();
    config(['database.default' => env('DB_CONNECTION')]);
    if ($package_title) {
      $package_duration = [];
      $packages = [];
      foreach ($package_title as $details) {
        if (!in_array($details->package_duration, $package_duration)) {
          $package_duration[] = $details->package_duration;
        }
        // Add the package_title to the $packages array if it's not already there
        if (!in_array($details->package_title, $packages)) {
          $packages[] = $details->package_title;
        }
      }

      return response()->json(['packages' => $packages, "package_duration" => $package_duration], 200);
    } else {
      return  response()->json(["error" => "data not here"], 500);
    }
  }
  public function StoreSubscriptionData(Request $request)
  {

    function calculateEndDateAndDays($startDate, $planType, $numberOfMonths)
    {
      $startDateObj = Carbon::createFromFormat('Y-m-d', $startDate);

      // Add the specified number of months to the start date
      $startDateObj->addMonths($numberOfMonths);

      // Handle different plan types (optional)
      switch ($planType) {
        case 'Month':
          break;
        case 'Years':
          $startDateObj->addYears($numberOfMonths);
          break;
        case 'Months':
          break;
        default:
          echo 'Invalid plan type';
          return null;
      }
      $endDate = $startDateObj->subDay()->format('Y-m-d');
      $numberOfDays = $startDateObj->diffInDays(Carbon::createFromFormat('Y-m-d', $startDate));
      return ['endDate' => $endDate, 'numberOfDays' => $numberOfDays];
    }


    $data = $request->all();
    $noOfseats = $data['noOfseats'];
    $totalAmountPayble = $data['totalAmountPayble'];
    $PlansProductId = $data['PlansProductId'];
    $PlanMonth = $data['PlanMonth'];
    $month = explode(" ", $PlanMonth);
    $startDate = Carbon::today()->toDateString();
    $result = calculateEndDateAndDays($startDate, $month[1], $month[0]);
    $endDate = $result['endDate'] . PHP_EOL;
    $noOfDays = $result['numberOfDays'];
    $userId = session("user");
    config(['database.default' => "custom"]);
    $saveData = new Salesubscription();
    $saveData->user_id = $userId;
    $saveData->plan_id = $PlansProductId;
    $saveData->startdate = $startDate;
    $saveData->enddate = $endDate;
    $saveData->counter = $noOfDays;
    $saveData->no_of_seats = $noOfseats;
    $saveData->paid_amount = $totalAmountPayble;
    if ($saveData->save()) {
      config(['database.default' => env('DB_CONNECTION')]);
      return response()->json(["PlansData" => "Success"], 200);
    } else {
      config(['database.default' => env('DB_CONNECTION')]);
      return response()->json(["PlansError" => "Success"], 500);
    }
  }

  public function getSubscriptionAmout(Request $request)
  {
    $data = $request->all();
    $planName = $data['planName'];
    $duration = $data['duration'];
    $plan = $data['plan'];
    config(['database.default' => "custom"]);

    $getsubscriptiondata = Subscription::where("package_category", $planName)
      ->where("package_title", $plan)
      ->where("package_duration", $duration)
      ->first();
    if ($getsubscriptiondata) {
      $data = [
        "PlanName" => $getsubscriptiondata->package_category,
        "PlanDuration" => $getsubscriptiondata->package_duration,
        "PlanType" => $getsubscriptiondata->package_title,
        "subscription_price" => $getsubscriptiondata->subscription_price,
        "sub_discount" => $getsubscriptiondata->sub_discount,
        "subs_price" => $getsubscriptiondata->subs_price,
        "tax_rate" => $getsubscriptiondata->tax_rate,
        "total_price" => $getsubscriptiondata->total_price,
        "packagecode" =>  $getsubscriptiondata->packagecode,
      ];
      config(['database.default' => env('DB_CONNECTION')]);
      return response()->json($data, 200);
    } else {
      config(['database.default' => env('DB_CONNECTION')]);
      return response()->json(['Error', "Data not Found"], 500);
    }
  }

  public function index(Request $request)
  {
    config(['database.default' => "custom"]);
    $package_title = $request['plan'];
    $package_duration = $request['duration'];
    $getsubscriptiondata = Subscription::where("status", 1)
      ->where('package_title', $package_title)
      ->where('package_duration', $package_duration)
      ->orWhere('package_title', 'Trial')
      ->get();
    $plansData = [];
    if ($getsubscriptiondata) {
      foreach ($getsubscriptiondata as $data) {

        $planObject = [
          'subs_price' => $data->subs_price,
          'subscription_price' => $data->subscription_price,
          'features' => explode(",", $data->features),
          'package_title' => $data->package_title,
          'package_duration' => $data->package_duration
        ];

        // Use the subscription ID ($data->id) as the key for the $plansData array
        $plansData[$data->package_category] = $planObject;;
      }
    }
    config(['database.default' => env('DB_CONNECTION')]);
    return response()->json($plansData);
  }

  public function store(Request $request)
  {
    $data = new Subscription();
    //$data->packagecode = (string) Str::uuid();
    $data->package_category = $request->package_category;
    $data->package_title = $request->package_title;
    $data->package_duration = $request->package_duration;
    $data->subscription_price = $request->subscription_price;
    $data->sub_discount = $request->sub_discount;
    $data->subs_price = $request->subs_price;
    $selectedFeatures = $request->input('features', []);
    $commaSeparatedFeatures = implode(',', $selectedFeatures);
    $data->features = $commaSeparatedFeatures;

    // Generate a unique ID using UUID
    $uniqueId = (string) Str::uuid();

    // Combine the custom prefix, unique ID, and "001"
    $data->packagecode = 'smart' . '001';
    $data->save();
    return back()->with('success', 'success');
  }

  public function feature(Request $request)
  {
    $data = new Feature();
    $data->feature = $request->feature;
    $data->save();
    return back()->with('feature', 'save feature addded');
  }
  public function destroy($id)
  {
    $data = Subscription::find($id);
    $data->delete();
    return back()->with('destroy', 'delete successfully');
  }
  public function featuredelete($id)
  {

    $data = Feature::find($id);
    $data->delete();
    return back()->with('delete', 'delete successfully');
  }
}
