<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\Item;
use Illuminate\Support\Facades\Validator;

use DB;

class ItemController extends Controller
{
    public function store(Request $request)
    {
        $request->validate([
            'itemcode' => 'required|unique:items',
            'itemname' => 'required',
            'rate' => 'required|numeric',
            'tax' => 'required|numeric',
            'amount' => 'required|numeric'
        ]);
        // return $request->input();
        $data = new Item();
        $data->itemcode = $request->itemcode;
        $data->itemname = $request->itemname;
        $data->rate = $request->rate;
        $data->tax = $request->tax;
        $data->amount = $request->amount;
        $data->save();
        return back()->with('ItemAdded', 'Item Added Successfully !');
    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $itemdata =  Item::find($id);
        return response()->json([
            'status' => 200,
            'itemdata' => $itemdata,
        ]);
    }
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'itemcode' => 'required|unique:items,itemcode,' . $request->input('item_id'),
            'itemname' => 'required',
            'rate' => 'required|numeric',
            'tax' => 'required|numeric',
            'amount' => 'required|numeric'
        ]);
        if ($validator->fails()) {
            $firstErrorMessage = $validator->errors()->first();
            return back()->with('error', $firstErrorMessage);
        }
        $item_id = $request->input('item_id');
        $data =  Item::find($item_id);
        if ($data) {
            $data->itemcode = $request->itemcode;
            $data->itemname = $request->itemname;
            $data->rate = $request->rate;
            $data->tax = $request->tax;
            $data->amount = $request->amount;
            $data->save();
            return redirect('additem')->with('warning', 'Item Updated Successfully. !');
        } else {
            return back()->with('error', 'Data not found.');
        }
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $data = Item::find($id);
        $data->delete();
        return back()->with('danger', 'Item Deleted Successfully. !');;
    }
}
