<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Leadmanager;
use App\Models\Businessregister;
use DB;
use App\Models\Permissions;
use App\Models\MessageManager;

class LeadmanagerController extends Controller
{

    private function checkWhatsAppPermission(): bool
    {
        try {
            $permission = Permissions::where('permissionType', 'Desktop Whatsapp')->value('permission');
            return $permission ?? false; // Return the permission value or false if not found

        } catch (ModelNotFoundException $e) {
            return false; // Handle the case when the permission is not found

        } catch (Exception $e) {
            // Log or handle other exceptions
            return false;
        }
    }
    public function BussinessDetails()
    {
        $userName = session("user");
        $whatAppPermisstion =  $this->checkWhatsAppPermission();
        $liseneceNo = session('liseneceNo');
        config(['database.default' => env('DB_CONNECTION')]);
        $BussinessData = Businessregister::where('username', $userName)
            ->where("license_no", $liseneceNo)
            ->first();
        // message template 
        $messageTemplate = MessageManager::where('msg_type', 'lead_reminder')->where('status',1)->value('msg');
        $data = [
            'hostelName' => $BussinessData->businessname,
            'contect' => $BussinessData->mobile,
            'email' => $BussinessData->email,
            'whatsAppPermission' =>$whatAppPermisstion,
            'messageTemplate' => $messageTemplate,
        ];
        return response()->json(['data' => $data], 200);
    }
    public function index($id)
    {
        $leadmanagerdata = Leadmanager::find($id);
        if ($leadmanagerdata) {
            return response()->json([
                'status' => 200,
                'leadmanagerdata' => $leadmanagerdata,
            ]);
        } else {
            // Handle the case when the Leadmanager instance is not found
            return response()->json([
                'status' => 404,
                'message' => 'Leadmanager not found',
            ]);
        }
    }
    public function store(Request $request)
    {
        $data = new Leadmanager();
        $data->leaddate = $request->leaddate;
        $data->created_at = $request->created_at;
        $data->leadcandidatename = $request->leadcandidatename;
        $data->leadmobile = $request->leadmobile;
        $data->leadmail = $request->leadmail;
        $data->requirement = $request->requirement;
        $data->budget = $request->budget;
        $data->location = $request->location;
        $data->save();
        return back()->with('lead', 'Lead Added Successfully.');
    }
    public function changeStatus(Request $request, $id)
    {
        $leadmanager = Leadmanager::find($request->leadmanager_id);
        if ($leadmanager) {
            $leadmanager->leadstatus = 1; // Set status to 1
            $leadmanager->save();
            return response()->json([
                'status' => 200,
                'message' => 'Status Updated Successfully'
            ]);
        } else {
            return response()->json([
                'status' => 404,
                'message' => 'Leadmanager not found'
            ]);
        }
    }
    public function delete($id)
    {
        $user = Leadmanager::find($id);
        $user->delete();
        return back()->with('delete', 'Status Change');
    }
}
