<?php

namespace App\Http\Controllers;

use App\Models\Businessregister;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Session;
use Illuminate\Support\Facades\Config;
use DB;
use App\Models\EmployeRegister;
use App\Models\Salesubscription;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;



class LoginController extends Controller
{
    public function ChangeUserPassword(Request $request)
    {
        $password = $request->password;
        $newPassword = $request->newPassword;
        if ($password == $newPassword) {
            return back()->with("PasswordError", "Current Password and New Password are same.");
        }
        $userId = session("user");
        $hostelName = session('hostel');
        $liseneceNo = session("liseneceNo");
        $userRoll = session("userRoll");
        $empId = session("empId");
        config(['database.default' => env('DB_CONNECTION')]);
        if ($userRoll != "Admin") {
            $emp = EmployeRegister::where("username", $userId)
                ->where("id", $empId)
                ->where("license_no", $liseneceNo)
                ->first();
            if ($emp) {
                $emp->password = Hash::make($newPassword);
                if ($emp->save()) {
                    return back()->with("PasswordChange", "Your Password has been changeed.");
                } else {
                    return back()->with("PasswordError", "Somthing Wronge!");
                }
            } else {
                return back()->with("PasswordError", "Your Old Password is not correct!");
            }
        } else {
            $admin = Businessregister::where('username', $userId)
                ->where("businessname", $hostelName)
                ->where("license_no", $liseneceNo)
                ->first();
            if ($admin) {
                $admin->password = Hash::make($newPassword);
                if ($admin->save()) {
                    return back()->with("PasswordChange", "Your Password has been changed.");
                } else {
                    return back()->with("PasswordError", "Somthing Wronge!");
                }
            } else {
                return back()->with("PasswordError", "Your Old Password is not correct!");
            }
        }
    }
    public function getUserName()
    {
        config(['database.default' => env('DB_CONNECTION')]);
        $userID = session('user');
        $admin = Businessregister::where('username', $userID)->first();
        return response()->json([
            'username1' => $admin->username,
            'username2' => $admin->username1
        ]);
    }
    private function getHostelList($userName)
    {
        try {
            $adminlist = [];
            config(['database.default' => env('DB_CONNECTION')]);
            $admin = Businessregister::where(function ($query) use ($userName) {
                $query->where('username', $userName)
                    ->orWhere('username1', $userName);
            })->get();
            if ($admin) {
                foreach ($admin as $data) {
                    $adminlist[] = $data->businessname;
                }
                return $adminlist;
            } else {
                return [];
            }
        } catch (Exception $e) {
            return [];
        }
    }
    public function getAdminsData(Request $request)
    {
        $userName = $request['userValue'];
        $userType = $request['userType'];
        $adminlist = [];
        try {
            config(['database.default' => env('DB_CONNECTION')]);
            if (strtolower($userType) !== "admin") {
                $emp = EmployeRegister::where(function ($query) use ($userName) {
                    $query->where("email", $userName)
                        ->orwhere("mobile", $userName);
                })
                    ->get();
                if (!empty($emp)) {
                    foreach ($emp as $val) {
                        $businessname = Businessregister::where('license_no', $val->license_no)->value('businessname');
                        if (!in_array($businessname, $adminlist)) {
                            $adminlist[] = $businessname;
                        }
                    }
                }
            } else {
                $adminlist =  $this->getHostelList($userName);
            }
            return response()->json($adminlist);
        } catch (Exception $e) {
            return response()->json(["error" => "data not found"], 500);
        }
    }
    public function EmailValidation(Request $request)
    {
        $userEmail = $request['userEmail'];
        try {
            config(['database.default' => env('DB_CONNECTION')]);
            $admin = Businessregister::where('email', $userEmail)->count();
            return response()->json($admin, 200);
        } catch (Exception $e) {
            return response()->json(["error" => "data not found"], 500);
        }
    }
    public function MobileNoValidation(Request $request)
    {
        $userMobile = $request['userMobile'];
        try {
            $admin = Businessregister::where('mobile', $userMobile)->count();
            return response()->json($admin, 200);
        } catch (Exception $e) {
            return response()->json(["error" => "data not found"], 500);
        }
    }
    public function BussinessNameValidation(Request $request)
    {
        $businessname = $request['businessName'];
        try {
            $admin = Businessregister::where('businessname', $businessname)->count();
            return response()->json($admin, 200);
        } catch (Exception $e) {
            return response()->json(["error" => "data not found"], 500);
        }
    }

    public function passwordCheck(Request $request)
    {
        try {
            $username = $request->username;
            $type = $request->type;
            if (empty($username) || empty($type)) {
                return response()->json([
                    'status' => false,
                    "message" => "Invalid input data"
                ], 500);
            }
            $user = Businessregister::where($type, $username)
                ->whereNull('password')
                ->orWhere('password', '')
                ->firstOrFail();
            // Check if user is found and the password field is not empty
            if ($user) {
                return response()->json([
                    'status' => false,
                    'data' => [
                        'email' => $user->email,
                        'mobile' => $user->mobile,
                    ],
                    "message" => "Password does not exist"
                ], 200);
            }
        } catch (Exception $e) {
            return response()->json([
                'status' => true,
                "message" => "Password already exist please login."
            ], 200);
        }
    }

    public function createUserPassword(Request $request)
    {
        try {
            $validator = Validator::make($request->all(), [
                'userType' => 'required|string',
                'userName' => 'required|string',
                'password' => [
                    'required',
                    'min:8',
                ],
                'conf_password' => 'required|same:password',
            ], [
                'password.regex' => 'Password must contain at least one uppercase letter, one lowercase letter, one number, and one special character.',
                'conf_password.same' => 'The confirmation password does not match.',
            ]);

            // Check if validation fails
            if ($validator->fails()) {
                return back()->withErrors($validator)->withInput();
            }

            $user = Businessregister::where($request->userType, $request->userName)
                ->where(function ($query) {
                    $query->whereNull('password')
                        ->orWhere('password', '');
                })
                ->firstOrFail();

            if ($user) {
                $user->password = Hash::make($request->password);
                $user->save();
                return back()->with('success', 'Password Created Successfully');
            } else {
                return back()->with('error', 'Something went wrong');
            }
        } catch (Exception $e) {
            return back()->with('error', 'Something went wrong');
        }
    }

    public function index()
    {
        $admin = Auth::Businessregister()->get();
        return view('fronted.index', compact('admin'));
    }
    public function logincheck(Request $request)
    {
        $this->validate($request, [
            'userRoll' => 'required',
            'username'   => 'required',
            'password'  => 'required'
        ]);

        function setCustomDatabaseConfig($db_username, $db_password, $db_name, $db_host, $db_port)
        {
            Config::set('database.connections.custom_db.username', $db_username);
            Config::set('database.connections.custom_db.password', $db_password);
            Config::set('database.connections.custom_db.database', $db_name);
            Config::set('database.connections.custom_db.host', $db_host);
            Config::set('database.connections.custom_db.port', $db_port);
            return 1;
        }
        $credentials = $request->username;
        $password = $request->password;
        $passwordValidation = false;

        config(['database.default' => env('DB_CONNECTION')]);


        if (strtolower($request->userRoll) !== "admin") {
            //For emp Login
            $liceneseNoOfHostel = Businessregister::where('businessname', $request->HostelName)->value('license_no');
            $emp = EmployeRegister::where(function ($query) use ($credentials) {
                $query->where("email", $credentials)
                    ->orWhere("mobile", $credentials);
            })
                ->where("user_roll", $request->userRoll)
                ->where('license_no', $liceneseNoOfHostel)
                ->with(['businessRegister' => function ($query) use ($request) {
                    $query->where("businessname", $request->HostelName); // Assuming 'hostel_name' is the column in 'business_registers' table
                }])
                ->first();
            if (!empty($emp) && ($emp->businessRegister->businessname == $request->HostelName)) {
                if (Hash::check($password, $emp->password)) {
                    Session::put("UserPermission", json_decode($emp->permissions,true));
                    Session::put("empId", $emp->id);
                    $admin = $emp->businessRegister;
                    if (!$admin) {
                        return back()->with('error', 'User is not authorized to access this system');
                    }
                    $passwordValidation = true;
                } else {
                    return back()->with('error', 'Invalid  Password');
                }
            } else {
                return back()->with("error", "Username is invalid !");
            }
        } else {
            $admin = DB::table('businessregisters')
                ->where(function ($query) use ($credentials) {
                    $query->where('username', $credentials)
                        ->orWhere('username1', $credentials);
                })
                ->where('businessname', $request->HostelName)
                ->first();

            if (!empty($admin) && Hash::check($password, $admin->password)) {
                $passwordValidation = true;
            } else {
                $passwordValidation = false;
            }
        }
        if (empty($admin)) {
            return redirect()->back()->with('error', 'Username is invalid !');
        } else {
            if ($passwordValidation == true) {
                $db_username = $admin->db_username;
                $db_password = $admin->db_password;
                $db_name = $admin->db_name;
                $db_host = $admin->db_host;
                $db_port = $admin->db_port;
                $db_status = $admin->db_status;
                if ($db_status == 1) {
                    $update = setCustomDatabaseConfig($db_username, $db_password, $db_name, $db_host, $db_port);
                    if ($update == 1) {
                        session(['dynamic_db_username' => $db_username]);
                        session(['dynamic_db_password' => $db_password]);
                        session(['dynamic_db_name' => $db_name]);
                        session(['dynamic_db_host' => $db_host]);
                        session(['dynamic_db_port' => $db_port]);
                        session()->put("dynamic_db_connection", 'custom_db');
                        $newTable = DB::table('businessregisters')
                            ->where(function ($query) use ($credentials) {
                                $query->where('username', $credentials)
                                    ->orWhere('username1', $credentials);
                            })
                            ->where('businessname', $request->HostelName)
                            ->first();
                        $request->session()->put('user', $admin->username);
                        Session::put("hostel", "$admin->businessname");
                        Session::put("liseneceNo", "$admin->license_no");
                        Session::put("userRoll", "$request->userRoll");
                        config(['database.default' => env('DB_CONNECTION')]);
                        return redirect('index')->with('login', 'welcome Admin Panel');
                    }
                } else {
                    return back()->with("error", "Your account has not been activated yet, please wait for some moment. Or contact us on 9516760054");
                }
            } else {
                return redirect()->back()->with('error', 'Password is Invalid !');
            }
        }
    }
    public function logout(Request $request)
    {
        Session::flush();
        Auth::logout();
        return redirect('/')->with('logout', 'logout Successfully');
    }
}
