<?php
namespace App\Http\Controllers;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use App\Models\Permissions;
use Illuminate\Database\Eloquent\ModelNotFoundException;
class PermissionController extends Controller
{
    public function view(){
        $allPermission = Permissions::all();
        return view('fronted.permission',compact('allPermission'));
    }
    

    public function update(Request $request, $id) {
        try {
            // Find the permission by ID
            $checkPermission = Permissions::findOrFail($id);
    
            // Update the permission
            $checkPermission->update([
                'permission' => $request->permission, // Assuming 0 for false and 1 for true
            ]);
    
            // Return a success response or redirect
            return response()->json(['message' => 'Permission updated successfully']);
    
        } catch (ModelNotFoundException $e) {
            // Handle the case when the permission is not found
            return response()->json(['error' => 'Permission not found'], 404);
    
        } catch (\Exception $e) {
            // Handle other exceptions
            return response()->json(['error' => $e->getMessage()], 500);
        }
    }

    public function checkWhatsppPermission():bool
    {
        try {
            $permission = Permissions::where('permissionType', 'Desktop Whatsapp')->value('permission');
            return $permission ?? false;

        } catch (ModelNotFoundException $e) {
            return false;

        } catch (Exception $e) {
            return false;
        }
    }
    
}