<?php

namespace App\Http\Controllers;

use App\Models\State;
use DB;
use Illuminate\Http\Request;

class StateController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $statecount = DB::table('states')->count();
        return view('fronted.add_state', compact('statecount'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //   return $request->input();
        $request->validate([
            'country_id' => 'required',
            'state_name' => 'required',
            'city_name' => 'required',
            'pincode' => 'required',

        ]);

        $data = new State();
        $data->country_id = $request->country_id;
        $data->state_name = $request->state_name;
        $data->city_name = $request->city_name;
        $data->pincode = $request->pincode;
        $data->save();
        return back()->with('success', 'Its a Submit!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = State::find($id);
        $data->state_name = $request->state_name;
        $data->update();
        return back()->with('success', ' update!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $data = State::find($id);
        $data->delete();
        return back();
    }
}
