<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Models\Uploadprofile;
use Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Storage;
use App\Models\Businessregister;



class UploadprofileController extends Controller
{

    private function uploadDocumentInAdminPanel($documentType, $filename): bool
    {
        try {
            config(['database.default' => env('DB_CONNECTION')]);
            $licenseNo = session("liseneceNo");
            $documentUpload = Businessregister::where('license_no', $licenseNo)->first();
            if ($documentUpload) {
                if ($documentType == 'Rules & Regulations') {
                    $documentUpload->rulesandregulations = $filename;
                } elseif ($documentType == "GST Certificate") {
                    $documentUpload->gstcertificate = $filename;
                } elseif ($documentType == "Pancard") {
                    $documentUpload->pancard = $filename;
                } elseif ($documentType == "Business Reg. Certificate") {
                    $documentUpload->businesscertificate = $filename;
                } elseif ($documentType == "Stamp With Signature") {
                    $documentUpload->stampwithsignature = $filename;
                } else {
                    throw new Exception('Invalid document type');
                }
                if ($documentUpload->update()) {
                    return true;
                } else {
                    throw new Exception('Failed to update document');
                }
            } else {
                throw new Exception("record not found");
            }
        } catch (Exception $e) {
            return false;
        } finally {
            config(['database.default' => 'custom_db']);
        }
    }


    public function store(Request $request)
    {
        $uploadtype = $request->upload_name;
        $profile = DB::table('uploadprofiles')->where('upload_name', $uploadtype)->first();
        if ($profile) {
            if ($request->hasfile('upload_pdf')) {
                $file = $request->file('upload_pdf');
                $extention =  $file->getClientOriginalExtension();
                if ($uploadtype == 'Rules & Regulations' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($uploadtype, $filename);
                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    // Perform the update query
                    DB::table('uploadprofiles')->where('upload_name', $uploadtype)->update([
                        // Set the columns to be updated and their new values
                        'upload_pdf' => $filename,
                        // Add more columns and their values as needed
                    ]);
                    return back()->with('upload', 'Upload Successfully');
                }
                if ($uploadtype == 'GST Certificate' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($uploadtype, $filename);
                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    // Perform the update query
                    DB::table('uploadprofiles')->where('upload_name', $uploadtype)->update([
                        // Set the columns to be updated and their new values
                        'upload_pdf' => $filename,
                        // Add more columns and their values as needed
                    ]);
                    return back()->with('upload', 'Upload Successfully');
                }
                if ($uploadtype == 'Pancard' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($uploadtype, $filename);
                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    // Perform the update query
                    DB::table('uploadprofiles')->where('upload_name', $uploadtype)->update([
                        // Set the columns to be updated and their new values
                        'upload_pdf' => $filename,
                        // Add more columns and their values as needed
                    ]);
                    return back()->with('upload', 'Upload Successfully');
                }
                if ($uploadtype == 'Business Reg. Certificate' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($uploadtype, $filename);
                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    // Perform the update query
                    DB::table('uploadprofiles')->where('upload_name', $uploadtype)->update([
                        // Set the columns to be updated and their new values
                        'upload_pdf' => $filename,
                        // Add more columns and their values as needed
                    ]);
                    return back()->with('upload', 'Upload Successfully');
                } else if ($uploadtype == 'Stamp With Signature' && ($extention == 'jpg' || $extention == 'png' || $extention == 'jpeg')) {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    // Perform the update query
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($uploadtype, $filename);
                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    DB::table('uploadprofiles')->where('upload_name', $uploadtype)->update([
                        // Set the columns to be updated and their new values
                        'upload_pdf' => $filename,
                        // Add more columns and their values as needed
                    ]);
                    return back()->with('upload', 'Upload Successfully');
                } else if ($request->upload_name == "T&C_for_emp" && ($extention == 'pdf')) {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($request->upload_name, $filename);

                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    DB::table('uploadprofiles')->where('upload_name', $uploadtype)->update([
                        // Set the columns to be updated and their new values
                        'upload_pdf' => $filename,
                        // Add more columns and their values as needed
                    ]);
                    return back()->with('upload', 'Upload Successfully');
                } else {
                    return back()->with('pdf', 'Tesitng');
                }
            }
        } else {
            $data = new Uploadprofile();
            $data->upload_name = $request->upload_name;
            if ($request->hasfile('upload_pdf')) {
                $file = $request->file('upload_pdf');
                $extention =  $file->getClientOriginalExtension();
                if ($request->upload_name == 'Rules & Regulations' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($request->upload_name, $filename);
                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    $data->upload_pdf = $filename;
                    $data->save();
                    return back()->with('upload', 'Upload Successfully');
                }
                if ($request->upload_name == 'GST Certificate' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($request->upload_name, $filename);

                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    $data->upload_pdf = $filename;
                    $data->save();
                    return back()->with('upload', 'Upload Successfully');
                }
                if ($request->upload_name == 'Pancard' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($request->upload_name, $filename);

                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    $data->upload_pdf = $filename;
                    $data->save();
                    return back()->with('upload', 'Upload Successfully');
                }
                if ($request->upload_name == 'Business Reg. Certificate' && $extention == 'pdf') {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($request->upload_name, $filename);

                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    $data->upload_pdf = $filename;
                    $data->save();
                    return back()->with('upload', 'Upload Successfully');
                } else if ($request->upload_name == 'Stamp With Signature' && ($extention == 'jpg' || $extention == 'png' || $extention == 'jpeg')) {
                    $filename = time() . '_' . rand() . '.' . $extention;
                    $file->move('assets/uploads/pdf/', $filename);
                    $finalPath = 'uploads/pdf/' . $filename;
                    $document = $this->uploadDocumentInAdminPanel($request->upload_name, $filename);

                    Storage::disk('external_images')->put($finalPath, file_get_contents('assets/uploads/pdf/' . $filename));
                    $data->upload_pdf = $filename;
                    $data->save();
                    return back()->with('upload', 'Upload Successfully');
                } else {
                    return back()->with('pdf', 'Tesitng');
                }
            }
        }
    }
}
