<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Auth;
use App\Models\ApiModels\UserAuthTokens;
use App\Models\ApiModels\BussinessModel;
use App\Models\Salesubscription;
use App\Models\Subscription;
use DB;

class CheckSubscriptionPermissionForApi
{
    public function handle($request, Closure $next, $permission)
    {
        // Retrieve the authenticated user from the toke
      
        $token = $request->header('Authorization');
        if (!$token) {
            return $next($request);
        }
        $userData = UserAuthTokens::where('token', $token)->first();
        if (!$userData) {
            return response()->json(['error' => 'Invalid token'], 401);
        }
        $licenceno = $userData->licenceno;

        //get permission  of this licence
        $permissionsArray = $this->getPermissions($licenceno);
        request()->attributes->set('permissions', $permissionsArray);
        // dd($permission,$permissionsArray);
        if (!in_array($permission, $permissionsArray)) {
            return response()->json([
                'status' => false,
                'message' => "You do not have permission to access this resource."
            ]);
        }
        return $next($request);
    }

    private function getPermissions($licenceno)
    {
        $plan = Salesubscription::select('plan_id')->where('user_id', $licenceno)->where('status', 1)->first();
        $defaultPermission = ['Home', 'RoomSeats', 'Subscription'];

        if ($plan) {
            $subscriptionPermissions = Subscription::select('permission')->where('packagecode', $plan->plan_id)->first();
            if ($subscriptionPermissions) {
                $permissionsArray = explode(',', $subscriptionPermissions->permission);
                return $permissionsArray;
            }
        } else {
            return $defaultPermission;
        }
    }
}
