<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Config;

class SetDynamicDatabaseConnection
{
    public function handle($request, Closure $next)
    {
        // Get the dynamic database connection name from the session or cache
        $dynamicConnection = session('dynamic_db_connection');

    
        // Set the default database connection to the dynamic connection

        $db_username = session('dynamic_db_username');
        $db_password = session('dynamic_db_password');
        $db_name = session('dynamic_db_name');
        $db_host = session('dynamic_db_host');
        $db_port = session('dynamic_db_port');
    
        // Check if you have the custom database connection information
        if ($db_username && $db_password && $db_name && $db_host && $db_port) {
            Config::set('database.connections.custom_db.username', $db_username);
            Config::set('database.connections.custom_db.password', $db_password);
            Config::set('database.connections.custom_db.database', $db_name);
            Config::set('database.connections.custom_db.host', $db_host);
            Config::set('database.connections.custom_db.port', $db_port);
    
            \DB::connection('custom_db')->reconnect();
        }
        
        if ($dynamicConnection) {
            config(['database.default' => $dynamicConnection]);
        }
        if ($request->is('logout')) {
            // Reset the database connection to the default database configuration
            config(['database.default' => env('DB_CONNECTION')]);
        }

        return $next($request);
    }
}
